#!/bin/bash

# Define source and destination directories
src_dir="/home/zfh/aird"
dest_dir="/home/zfh/aird_backup_his/$(date +%F)"

# clear the old backup
if [ -d "$dest_dir" ]; then
    rm -rf "$dest_dir"
    rm -f $dest_dir.tar.gz
fi

mkdir -p "$dest_dir"

if [ ! -d "$dest_dir/model/ckpt" ]; then
    mkdir -p "$dest_dir/model/ckpt"
fi
# Copy directories and files to destination directory
exclusions=(tools tuning .env)
exclusions+=("__pycache__/")
rsync -av "${exclusions[@]/#/--exclude=}" "${src_dir}/src/" "${dest_dir}/src/"

# Define the list of directories to copy
# dirs_to_copy=(chatglm2-6b-qlora-spdsvb-INSv9 chatglm-6b-pt-spdsvb-INSv9-128-5e-3-3000 chatglm2-6b-pt-spdsvb-INSv11-128-5e-3-3010 chatglm2-6b-qlora-INSv11-rank16-1e-3-30)
# rsync -av "${dirs_to_copy[@]/#/${src_dir}\/model\/ckpt\/}" "${dest_dir}/model/ckpt/"

# rsync -av $src_dir/model/moka-ai/ $dest_dir/model/moka-ai/
rsync -av $src_dir/deps $dest_dir/

cp $src_dir/Dockerfile $dest_dir/Dockerfile
cp $src_dir/Makefile $dest_dir/Makefile
cp $src_dir/.dockerignore $dest_dir/.dockerignore

sed -i 's/\/home\/zfh/\/home\/ssvb/g' $dest_dir/src/common/consts.py

# Create a tar archive of the destination directory
# tar -czvf $dest_dir.tar.gz $dest_dir
tar -czvf /home/zfh/deploy/aird.$(date +%F).tar.gz -C $dest_dir .
rm -f /home/zfh/deploy/aird_backup
ln -sf $dest_dir /home/zfh/deploy/aird_backup