
from typing import List
from langchain.schema import Document
from langchain.callbacks.base import (
    BaseCallbackHandler,
    BaseCallbackManager
)

class PrintRetrievalHandler(BaseCallbackHandler):
    '''
    回调，输出查询使用的相似性文档
    '''
    def __init__(self) -> None:
        super().__init__()
        self.similarity:dict = []
        
    def on_retriever_start(self, query: str, **kwargs):
        print(f"**Question:** {query}")

    def on_retriever_end(self, documents, **kwargs):
        self.similarity = [{"page_content":doc.page_content,"from_file":doc.metadata["filename"] or "","page_number":doc.metadata["page_number"] or 0} for doc in documents]
    def getsimilarity(self)->List[Document]:
        return self.similarity