from flask import Flask, jsonify, request

import tempfile
import shutil

import sys
sys.path.append("../..") 

from llm.chatglm import ChatGLMLocLLM
from llm.ernie import ErnieLLM,ModelType
from llm.baichuan import BaichuanLLM
from loader.load import load_file,load
from contract.extraction import ElementsExtractor

app = Flask(__name__)

temp_dir = tempfile.mkdtemp()

# llm = ChatGLMLocLLM(model_name="/home/zfh/models/chatglm-6b")

llm = ErnieLLM(model_name=ModelType.ERNIE_LITE,access_token="24.a2dab1f44fdee40ff5fe1923d8dbdfcb.2592000.1692415837.282335-32870719")
               

extractor=ElementsExtractor(llm=llm)

@app.route('/contract', methods=['POST'])
def contract():
    # 获取文件对象
    print(request.files)
    file = request.files['file']
    if file is None:
        return jsonify({'message': 'Error: could not load file'})
    filename =temp_dir + '/' + file.filename 
    file.save(filename)

    # 解析其中的参数    
    elements = request.form.get('elements').split(",")
    max_length = request.form.get('max_length')
    max_length = int(max_length) if max_length is not None else 1000
    print(file,elements,max_length)
    # 调用模型
    docs = load(filename)
    if docs is None:
        return jsonify({'message': 'Error: could not load file'})
    print(len(docs))
    content = []
    content_len = 0
    values={}
    for e in elements:
        values[e]=""

    for d in docs:
        if content_len+len(d.page_content)>max_length:
            doc = "\n".join(content)
            eles = extractor.extract(doc,elements)
            for e in eles:
                try:
                    k,v = e.split("：",maxsplit=1)
                    k = k.strip()
                    v = v.strip()
                    if v is not None and v != "" and v!="未知" and k in elements:
                        values[k]=v+","+values[k] if k in values else v
                except Exception as exp:
                    print(exp)
                    print(e)
                    continue
            print("\n".join([f"{k}：{v}" for k,v in values.items()]))
            content=[d.page_content]
            content_len=len(d.page_content)
        else:
            content.append(d.page_content)
            content_len+=len(d.page_content)

    return jsonify(values)

@app.route('/example', methods=['GET'])
def example():
    return jsonify({'message': 'Hello World!'})

if __name__ == '__main__':
    app.run(debug=True,port=8080,host='0.0.0.0')