# -*- coding: utf-8 -*-
import sys
sys.path.append("../..") 

import pandas as pd
import gradio as gr
import argparse

from llm.chatglm import ChatGLMSerLLM
from langchain.chains import LLMChain
from langchain.prompts import PromptTemplate

from typing import Awaitable
import asyncio
from langchain.callbacks  import AsyncIteratorCallbackHandler
import re
import json
from llm.ernie_with_sdk import ChatERNIESerLLM
from qianfan import ChatCompletion

prompt1 = """'''
{context}
'''
请你根据上述已知资料回答下面的问题，问题如下：
{question}"""
PROMPT1 = PromptTemplate(input_variables=["context", "question"],template=prompt1)

def chat(input_text):
    global llmchain
    if not input_text:
        return ""
    result = llmchain.run({"context":input_text})
    return result

async def async_chat_stc(input_text):
    global base_llm1, base_llm2, step
    qianfanchain_stc = LLMChain(llm=base_llm2, prompt=PROMPT1,llm_kwargs={"temperature":0.9})
    callback = AsyncIteratorCallbackHandler()
    async def wrap_done(fn: Awaitable, event: asyncio.Event):
        try:
            await fn
        except Exception as e:
            import traceback
            traceback.print_exc()
            print(f"Caught exception: {e}")
        finally:
            event.set()
    task = asyncio.create_task(wrap_done(qianfanchain_stc.arun({"context":input_text},callbacks=[callback]),callback.done))
    print("*"*20)
    text=""
    async for token in callback.aiter():
        text=text+token
        yield f"{text}"
    await task