# -*- coding: utf-8 -*-
import os, sys

sys.path.append("../..") 


from langchain.chains import LLMChain

from llm.ernie_with_sdk import ChatERNIESerLLM
from qianfan import ChatCompletion
from langchain.prompts import PromptTemplate
import gradio as gr

from llm.chatglm import ChatGLMSerLLM
from langchain.chains import LLMChain
from langchain.prompts import PromptTemplate
from langchain.embeddings.huggingface import (
    HuggingFaceEmbeddings,
)
from sklearn.metrics.pairwise import cosine_similarity
import numpy as np


embedding_path = "C:\\Users\\15663\\AI\\models\\bge-large-zh-v1.5"
embedding = HuggingFaceEmbeddings(model_name=embedding_path)
qianfan_prompt_stc1 = """'''
{context}
'''

请为上述文本取一个标题（除标题之外不可输出其他内容）。"""
QIANFAN_PROMPT_STC1 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_stc1)


qianfan_prompt_stc2 = """'''
{context}
'''

请为上述同级标题生成一个高级标题（除标题之外不可以输出其他内容）"""
QIANFAN_PROMPT_STC2 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_stc2)


chatglm_prompt_stc1 = """{context}

请为上述文本取一个标题（除标题之外不可输出其他内容）。"""
CHATGLM_PROMPT_STC1 = PromptTemplate(input_variables=["context"], template=chatglm_prompt_stc1)

chatglm_prompt_stc2 = """'''
{context}
'''

请为上述同级标题生成一个高级标题（除标题之外不可以输出其他内容）"""
CHATGLM_PROMPT_STC2 = PromptTemplate(input_variables=["context"], template=chatglm_prompt_stc2)


def get_para_list(input_text):
    o_para_list = input_text.split("\n")
    para_list = []
    for index,item in enumerate(o_para_list):
        if len(item.strip()) == 0:
            if len(para_list) == 0:
                para_list.append(item+'\n')
            else:
                para_list[-1] = para_list[-1] + '\n' + item
        elif len(item) <= 20:
            if index+1 < len(o_para_list):
                o_para_list[index+1] = item+"\n"+o_para_list[index+1]
                continue
            else:
                para_list.append(item)
        else:
            para_list.append(item)
    if len(para_list) >= 2 and all(char.isspace() for char in para_list[0]):
        tmp_str = para_list[0]
        para_list = para_list[1:]
        para_list[0] = tmp_str+para_list[0]
    # print(para_list)
    # print(len(para_list))
    return para_list

def split_plus1(para_list,split_threshold,split_threshold_para):
    print("-------------------------------------------------------------------------------------------------------------------")
    para_split = []
    para_info = []
    index_spilt = []
    cur_para = para_list[0]
    cur_index = 0
    cur_para_info = []
    cur_para_vec = embedding.embed_query(cur_para)
    cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
    last_centence_vec = cur_para_vec
    for index in range(1,len(para_list)):
        vec = embedding.embed_query(para_list[index])
        vec = np.array(vec)
        vec = vec.reshape(1,-1)
        similarity = cosine_similarity(cur_para_vec,vec)
        similarity2 = cosine_similarity(last_centence_vec,vec)
        if similarity > split_threshold_para or similarity2 > split_threshold:
            cur_para_info.append({"offset":len(cur_para)+1,"similarity":[similarity[0][0],similarity2[0][0]]})
            cur_para += "\n" + para_list[index]
            cur_para_vec = embedding.embed_query(cur_para)
            cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
        else:
            para_split.append(cur_para)
            para_info.append({"para_info":cur_para_info,"para_vec":cur_para_vec})
            index_spilt.append(cur_index)
            cur_para = para_list[index]
            cur_index = index
            cur_para_info=[{"offset":0,"similarity":[similarity[0][0],similarity2[0][0]]}]
            cur_para_vec = vec
        last_centence_vec = vec
    if len(cur_para)>0:
        para_split.append(cur_para)
        para_info.append({"para_info":cur_para_info,"para_vec":cur_para_vec})
        index_spilt.append(cur_index)
    # print(para_split)
    return para_split, para_info, index_spilt

def split_plus2(para_split, para_info, marge_threshold_para=0):
    result = []
    result_simple = []
    index_spilt = []
    def insert_info(para,info):
        for i in range(len(info)-1,-1,-1):
            para = para[:info[i]["offset"]] + "**与上段落相似 {:.5} 与上句相似 {:.5}**\n".format(info[i]["similarity"][0],info[i]["similarity"][1]) +para[info[i]["offset"]:]
        return para
    cache_para = ""
    cache_para_simple = ""
    last_para_vec = None
    cur_index = 0
    for index in range(len(para_split)):
        if len(para_info[index]["para_info"])>1:
            result.append(cache_para+insert_info(para_split[index],para_info[index]["para_info"]))
            result_simple.append(cache_para_simple+para_split[index])
            index_spilt.append(cur_index)
            # print(para_split[index],"-=-=-=")
            # print(index,"->",cur_index)
            cur_index = index+1
            # print(index, "insert_index1=======================================")
            cache_para = ""
            cache_para_simple = ""
            last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
        else:
            if index == len(para_split)-1:
                if len(result)>0:
                    result[-1] += "\n"+cache_para+insert_info(para_split[index],para_info[index]["para_info"])
                    result_simple[-1] += "\n"+cache_para_simple+para_split[index]
                    cur_index = index+1
                else:
                    result.append(cache_para+insert_info(para_split[index],para_info[index]["para_info"]))
                    result_simple.append(cache_para_simple+para_split[index])
                    index_spilt.append(cur_index)
                    cur_index = index+1
                cache_para = ""
                cache_para_simple = ""
                last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
            else:
                if index == 0:
                    cache_para += insert_info(para_split[index],para_info[index]["para_info"]) +"\n"
                    cache_para_simple += para_split[index]+ "\n"
                else:
                    if last_para_vec is not None:
                        last_similarity = cosine_similarity(para_info[index]["para_vec"],last_para_vec)[0][0]
                        last_para_vec = None
                    else:
                        last_similarity = para_info[index]["para_info"][0]["similarity"][0]
                    next_similarity = cosine_similarity(para_info[index]["para_vec"],para_info[index+1]["para_vec"])
                    if last_similarity > marge_threshold_para or next_similarity > marge_threshold_para or len(para_split[index]) < 50:
                        if last_similarity > next_similarity and len(result)>0:
                            result[-1] += "\n"+cache_para+insert_info(para_split[index],para_info[index]["para_info"])
                            result_simple[-1] += "\n"+cache_para_simple+para_split[index]
                            cur_index = index+1
                            cache_para = ""
                            cache_para_simple = ""
                            last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
                        else:
                            cache_para += insert_info(para_split[index],para_info[index]["para_info"])+"\n"
                            cache_para_simple += para_split[index]+ "\n"
                            last_para_vec = np.array(embedding.embed_query(cache_para)).reshape(1,-1)
                    else:
                        result.append(cache_para+insert_info(para_split[index],para_info[index]["para_info"]))
                        result_simple.append(cache_para_simple+para_split[index])
                        index_spilt.append(cur_index)
                        cur_index = index+1
                        last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
                        cache_para = ""
                        cache_para_simple = ""
    if len(cache_para)>0:
        result.append(cache_para)
        result_simple.append(cache_para_simple)
        index_spilt.append(cur_index)
    return result,result_simple,index_spilt


paragraph1 = """区域性优惠贸易协定项下出口货物原产地证明书(以下简称优惠原产地证)是有区域 性优惠贸易协定国家官方机构签发的享受成员国关税互惠减免待遇的官方凭证，是企业出口 产品通向国际市场的“金钥匙”和“有价证券”。凭借优惠原产地证，企业出口产品可以享 受优惠关税甚至零关税的待遇，从而有效降低产品出口成本，提高产品的国际竞争力。
自加入WTO 至今，我国已同有关国家和地区签署了如下的区域性优惠贸易协定，包括 《内地与港澳更紧密经贸关系安排 (CEPA)》  《亚太贸易协定》《中国一东盟自贸协定》《中 国一巴基斯坦自贸协定》 《中国一智利自贸协定》 《中国一新西兰自贸协定》 《中国一新加 坡自贸协定》 《中国一哥斯达黎加自贸协定》 《中国一秘鲁自贸协定》 《中国一瑞士自贸协 定》《中国—冰岛自贸协定》 《中国一韩国自贸协定》 《中国一澳大利亚自贸协定》海峡两 岸经济合作框架协议 (ECFA)  等，还有更多的自由贸易区正在谈判或研究之中。
目前贸促会受理以下地区的优惠原产地证  《亚太贸易协定》目的国：印度、韩国、孟  加拉、斯里兰卡、老挝 《中国一新西兰自由贸易协定》目的国：新西兰；  《中国一新加坡 自由贸易协定》目的国：新加坡 《中国一秘鲁自由贸易协定》目的国：秘鲁；海峡两岸经 济合作框架协议 (ECFA)  目的地：中国台湾 《中国一瑞士自由贸易协定》目的国：瑞士； 《中国 —冰岛自由贸易协定》目的国：冰岛  《中国一韩国自由贸易协定》目的国：韩国； 《中国一澳大利亚自由贸易协定》目的国：澳大利亚。
FORM  B证书是根据《亚太贸易协定》 (FIRST  AGREEMENT  ON  TRADE  NEGOTIATIONS AMONG DEVELOPING MEMBER COUNTRIES OF THE ECONOMIC AND SOCIAL COMMISSION FOR ASIA AND THE PACIFIC) 原产地规则的要求签发的前身为《曼谷协定》,是在签订协定 的成员国之间就特定产品享受互惠减免关税待遇(跟非互惠的FORM  A证书不同) 的官方 原产地证明文件。
FORM  B证书的签订依据为《亚太贸易协定》原产地规则和《亚太贸易协定原产地证 书签发和核查程序》。
可签发FORM  B 证书的国家为：中国、印度、斯里兰卡、孟加拉国、老挝和韩国(《亚 太贸易协定》成员国)。
如货物为完全原产，填写 “A”。如货物含进口成分，非国产价值成分<55%,填写字母   “B”加原产于非成员国或原产地不明的材料、部件或产品的总货值占出口产品离岸价的百分   比，例如( ‘B”40%)。  如货物含进口成分，国产及成员国累计价值成分≥60%,填写 “C” 加原产于成员国的累计含量的总值与出口产品离岸价的百分比，例如(  “℃”65%)。符合特  定原产地标准的产品，填写字母 “D”(该项主要针对不发达国家出口申报的产品)。
注意《亚太贸易协定》原产地证书申请时间不得超过货物出运后3个工作日。
FORM  E证书是根据《中华人民共和国与东南亚国家联盟全面经济合作框架协议》的要 求签发的、在签订协定的成员国之间就特定产品享受互惠减免关税待遇的(跟非互惠的 FORM  A证书不同)官方原产地证明文件。
FORME  证书的签订依据为《中国一东盟自由贸易区原产地规则》和《中国一东盟自170. 国际贸易单证实务由贸易区原产地规则签证操作程序》。
可签发FORME  证书的国家为：中国、老挝、越南、泰国、缅甸、柬埔寨、菲律宾、文 莱、印度尼西亚、马来西亚和新加坡(东盟成员国)。
如货物完全原产，填写“×”。如货物含进口成分，其国产价值成分≥40%,填写国产 价值的百分比，例如   “45%”。如货物含进口成分，中国一东盟自贸区累计价值成分≥ 40%,填写该累计价值的百分比，例如 “45%”。
注意：证书为一正三副， 一三联客户，二联商检留存，四联企业留存。
FORMP 证书是根据《中华人民共和国政府与巴基斯坦伊斯兰共和国政府关于自由贸易 协定早期收获计划的协议》(简称《早期收获协议》)及其项下《中国一巴基斯坦自由贸易 区原产地规则》的要求签发的在中国和巴基斯坦之间就特定产品享受互惠减免关税待遇的 (跟非互惠的FORMA  证书不同)官方原产地证明文件。
FORMP 证书的签订依据为《中国一巴基斯坦自由贸易区原产地规则》和《中国一巴基 斯坦自由贸易区原产地规则签证操作程序》。
可签发FORMP  证书的国家为中国和巴基斯坦。中国产品出口到巴基斯坦，中国出口商 向各地出入境检验检疫机构申请签发FORMP  证书，巴基斯坦给予FORM P证书项下货物关 税优惠待遇；巴基斯坦产品出口到中国，巴基斯坦出口商向巴基斯坦有关部门申请签发 FORMP  证书，中国给予FORMP  证书项下货物关税优惠待遇。这是互惠的。
如货物为完全原产，填写“P”; 如货物含进口成分，国产价值成分≥45%,填写国产价 值的百分比，例如   "40%";如货物含进口成分，中国一巴基斯坦自贸区累计价值成分≥ 40%,填写该累计价值的百分比，例如  “45%”;产品符合特定原产地标准，填写 “PSR”。
注意：出运后15日内办理。
FORMF 证书是根据《中国一智利自由贸易协定》及其项下《中国一智利自贸区原产地 规则》的要求签发的，在中国和智利之间就特定产品享受互惠减免关税待遇的(跟非互惠 的 FORM  A证书不同)官方原产地证明文件。
FORMF  证书的签订依据为《中国一智利自贸区原产地规则》和《中国一智利自由贸易 区原产地规则签证操作程序》。
可签发FORMF  证书的国家为中国和智利。中国产品出口到智利，中国出口商向各地出 入境检验检疫机构申请签发FORMF  证书，智利给予FORMF  证书项下货物关税优惠待遇； 智利产品出口到中国，智利出口商向智利有关部门申请签发FORMF  证书，中国给予FORM  F 证书项下货物关税优惠待遇。这是互惠的。
如货物为完全原产，填写 “P”; 如货物为含进口成分，区域价值成分≥40%,填写 “RVC"; 产品符合特定原产地标准，填写 “PSR”并附《中智自由贸易区产品特定原产地 标准》(简称 “PSR”清单)。
注意：证书的申办时间应在货物出口前或出口后的30天内；货物出口30天后，签证机 构不再接受证书的签发申请。
FORM N 证书是根据《中华人民共和国政府和新西兰政府自由贸易协定》和《中华人第五章 其他出口结汇单证.171.民共和国政府和新西兰政府自由贸易协定项下进出口货物原产地管理办法》的要求签发的、 在中国和新西兰之间就特定产品享受互惠减免关税待遇的(跟非互惠的FORM  A证书不同)  官方原产地证明文件。《中华人民共和国政府和新西兰政府自由贸易协定》于2008年4月7  日正式签署，这是中国与发达国家签署的第一个自由贸易协定。
可签发FORM  N 证书的国家为中国和新西兰。中国产品出口到新西兰，中国出口商向 各地出入境检验检疫机构申请签发FORM  N 证书，新西兰给予FORM  N证书项下货物关税 优惠待遇；新西兰产品出口到中国，新西兰出口商向新西兰有关部门申请签发 FORM  N 证 书，中国给予FORM  N证书项下货物关税优惠待遇。这是互惠的。
如货物为完全原产，填写 “WO”; 如货物含有进口成分，但完全由已经取得原产资格 的材料或部件生产，填写 “WP”; 产品符合特定原产地标准，填写 “PSR”, 有区域价值成 分要求的，应注明百分比，例如 “PSR”60%。
注意：证书申办时间：应在货物出口前或当天申请办理，中国一新西兰证书不办理后 发，不倒签。
FORMX  证书是根据 《中华人民共和国政府和新加坡共和国政府自由贸易协定》和 《中华人民共和国政府和新加坡共和国政府自由贸易协定项下进出口货物原产地管理办法》 的要求签发的，在中国和新加坡之间就特定产品享受互惠减免关税待遇的(跟非互惠的 FORM  A证书不同)官方原产地证明文件。
FORM  X 证书的签订依据为《中国一新加坡自贸协定原产地规则》及其相关的原产地签 证操作程序。
可签发FORM  X 证书的国家为中国和新加坡。中国产品出口到新加坡，中国出口商向 各地出入境检验检疫机构申请签发 FORM  X 证书，新加坡给予 FORM  X 证书项下货物关税 优惠待遇；新加坡产品出口到中国，新加坡出口商向新加坡有关部门申请签发 FORM  X 证 书，中国给予FORM  X证书项下货物关税优惠待遇。这是互惠的。
中国一新加坡自贸区原产地规则规定：在出口方完全获得的产品，填写 “P”; 区域价 值成分≥40%的产品，填写 “RVC"; 符合产品特定原产地规则的产品，填写 “PSR”。
注意：应在提单日期前申报，不办理后发证书。
证书英文名称： Certificate of Origin Form for China-Peru FTA。
中国一秘鲁FTA 证书是根据《中国一秘鲁自由贸易协定》及其项下《中国一秘鲁自贸 区原产地规则》的要求签发的、在中国和秘鲁之间就特定产品享受互惠减免关税待遇的 (跟非互惠的FORM  A证书不同)官方原产地证明文件。
中国一秘鲁FTA 证书的签订依据为《中国一秘鲁自贸区原产地规则》及与原产地相关 的签证操作程序。
可签发中国一秘鲁 FTA 证书的国家为中国和秘鲁。中国产品出口到秘鲁，中国出口商 向各地出入境检验检疫机构申请签发中国一秘鲁 FTA 证书，秘鲁给予中国一秘鲁FTA 证书 项下货物关税优惠待遇；秘鲁产品出口到中国，秘鲁出口商向秘鲁有关部门申请签发中国一 秘鲁FTA 证书，中国给予中国一秘鲁FTA 证书项下货物关税优惠待遇。这是互惠的。
FORML  证书是根据《中国一哥斯达黎加自由贸易协定》及其项下 《中国一哥斯达黎加国际贸易单证实务自贸区原产地规则》的要求签发的、在中国和哥斯达黎加之间就特定产品享受互惠减免关 税待遇的(跟非互惠的FORM  A证书不同)官方原产地证明文件。
FORML  证书的签订依据为《中国一哥斯达黎加自贸区原产地规则》及与原产地相关的 签证操作程序。
可签发FORML  证书的国家为中国和哥斯达黎加。中国产品出口到哥斯达黎加，中国出 口商向各地出入境检验检疫机构申请签发 FORML  证书，哥斯达黎加给予FORM  L证书项下 货物关税优惠待遇；哥斯达黎加产品出口到中国，哥斯达黎加出口商向哥斯达黎加有关部门 申请签发 FORML  证书，中国给予FORML  证书项下货物关税优惠待遇。这是互惠的。
FORMS  证书是根据《中华人民共和国和瑞士联邦自由贸易协定》及其相关规定的要求 签发的、在中国和瑞士之间就特定产品享受互惠减免关税待遇的(跟非互惠的 FORM  A 证 书不同)官方原产地证明文件。
FORMS  证书的签订依据为《中国一瑞士自由贸易区原产地规则》及其相关的原产地签 证操作程序。《中华人民共和国和瑞士联邦自由贸易协定》于2014年7月1日起施行。
可签发FORMS  证书的国家为中国和瑞士。中国产品出口到瑞士，中国出口商向各地出 入境检验检疫机构申请签发FORMS  证书，瑞士给予FORMS  证书项下货物关税优惠待遇； 瑞士产品出口到中国，瑞士出口商向瑞士有关部门申请签发FORMS  证书，中国给予FORM  S 证书项下货物关税优惠待遇。这是互惠的。
《海峡两岸经济合作框架协议》 (ECFA)  是台湾与大陆自2009年年中开始，经过多次 商谈达成的一项重要协议，于2010年6月29日签署，其项下货物贸易早期收获清单于2011 年 1 月 1 日起付诸实施，出口到台湾的货物将获得关税减免的优惠。
列入清单的约800项产品将逐步降关税，三年内全部降为零，包括大陆对台湾开放的产 品500多项，台湾批准大陆的产品5大类267项，含石化类、机械类、纺织类、运输类等产品。海峡两岸经济合作框架协议(英文为 ECONOMIC    COOPERATION    FRAMEWORKAGREEMENT,ECFA;     台湾方面的繁体版本称为海峡两岸经济合作架构协议),原称为两岸 综合性经济合作协定或称两岸综合经济合作协定(英文简称 CECA,  即 COMPREHENSIVEECONOMIC COOPERATION AGREEMENT)。
中国出口到韩国的原产地证， 一般叫作韩国原产地证，英文名为 CERTIFICATE  OF ORIGIN  FORM  FOR  CHINA-KOREA  FTA, 也可叫作韩国FTA 产地证FORM  K, 简称中韩原 产地证，是中国出口到韩国需要办理的原产地证之一。具体是指货物经中国出口至韩国时需 要向中国国际贸易促进委员会或中国出入境检验检疫局申请签发办理的一种用来证明所出口 的货物原产地或产品制造地为中国的证明文书。中韩 FTA 原产地证于2015年12月20日正 式生效并实施第一次降税，并于2016年1月1日实施第二次降税。而自2005年12月20日 起，凡是货物出口至韩国的出口企业均可向中国各地的出入境检验检疫机构申请签发中韩自 贸协定原产地证书；且只要是出口商在货物出口韩国时，向进口国海关出示由中国出入境检 验检疫局所办理的韩国原产地，其所随附原产地证书的出口货物将按照自贸协定可在韩国享 受优惠关税待遇。目前，货物经中国出口至韩国所需要办理的产地证有以下三种：第五章  其他出口结汇单证173(1) 一般原产地证CO。 从中国出口到韩国的货物在办理产地证时也可以选择办理一般  原产地证CO, 一般原产地证 CO 是全世界任何国家和地区均可以办理的一种原产地证书。 因此，货物出口韩国也可以选择办理一般原产地证CO, 该原产地证是产地证中的一种最基  础、最原始、最原籍的产地证书。但一般原产地证CO 只能作为货物的清关文件使用，相当  于一张货物的“入门票”,是不享有韩国的关税优惠减免待遇的，所以，在办理中国出口到  韩国的原产地证时，最好不要选择办理这种原产地证，但若是国外客户要求办理该产地证， 那么就具体地根据客户的要求来。
(2)亚太原产地证FORM  B。亚太原产地证是货物从中国出口到韩国时可以选择办理的 另外一种原产地证。由于韩国也是亚太地区成员国之一，因此货物从中国出口到韩国，选择 办理亚太原产地证也是一种较好的选择。该原产地证相对于一般原产地证 CO 来说，主要的 优势在于能够享受到进口目标国的关税优惠待遇，且也使货物能够进入韩国这个国家。
(3)韩国原产地证。韩国原产地证是一种区域性优惠原产地证，是中国近期与韩国签  订的一种外贸合作协定，简称中韩自贸协定，是一种专门针对韩国签发的原产地证书，也是  货物从中国出口到韩国时首选的原产地证。韩国原产地证不仅可以使得货物顺利清关，还能  享受到比亚太原产地证所规定的关税优惠更多的优惠待遇。因此，凡是货物出口至韩国时， 最好首先考虑选择办理韩国原产地证，其次才是亚太原产地证。
中国一韩国原产地证明书的签发，限于已公布的《货物贸易协定》项下给予关税优惠 的产品，这些产品必须符合《中国一韩国自由贸易区原产地规则》。
中国一澳大利亚原产地证，全称为《中国一澳大利亚自贸区》优惠原产地证，英文名称 为 CERTIFICATE  OF  ORIGIN  FORM  FOR  CHINA-AUSTRALIA  FREE  TRADE  AGREEMENT, 简 称中澳原产地证或 FORM   AU原产地证。中澳原产地证是根据《中国一澳大利亚自由贸易协 定》签发的、就中澳两国之间互相给予关税减免待遇的官方证明文件。
FORM   AU证书签订依据为《中国一澳大利亚原产地证规则》及其签证操作程序。 《中 国一澳大利亚自贸区》优惠原产地证采用专用证书格式， 一正一副，正本为深棕色，印有 钮索图案底纹，副本为白色。
签证产品 《中国 一澳大利亚原产地证明书》的签发，限于已公布的《货物贸易协定》 项下给予关税优惠的产品，这些产品必须符合《中国一澳大利亚自由贸易区原产地规则》。
请注意，不同种类的产地证出证要求不尽相同，不同的优惠原产地证可能有不同的特定 要求，如果不符合要求，就无法享受关税减免等优惠，所以一定要重视。"""
paragraph2 = """家，这个字眼在我们心中总是充满着无尽的温馨与和谐。它是我们心灵的港湾，是我们情感的归宿，是我们生活的起点与终点。在这个小小的世界里，我们与亲人共度时光，分享欢笑与泪水，品味生活的酸甜苦辣。
在这个家中，有着一位慈爱的父亲。他像一座坚实的山，为家庭提供着坚实的支撑。他每天早出晚归，辛勤工作，为了家人的幸福而努力拼搏。尽管他很少言语，但他的每一个眼神、每一个动作都透露出对家人的深深关爱。每当我们遇到困难时，他总是第一个站出来，为我们遮风挡雨，让我们感受到家的温暖与力量。
而母亲则是家中的灵魂，她用无私的爱和关怀，温暖着每一个人的心。她勤劳能干，把家里打理得井井有条。无论是可口的饭菜，还是整洁的居室，都凝聚着她的辛勤付出。她总是在我们最需要的时候，给予我们最温暖的拥抱和最贴心的安慰。她的笑容如同阳光般灿烂，照亮了我们前行的道路，让我们在人生的旅途中不再迷茫。
家中的孩子们则是这个温馨画面中最活泼的元素。他们天真无邪，充满好奇，给家带来了无尽的欢乐与生机。他们一起学习、一起玩耍，分享着彼此的喜怒哀乐。在成长的道路上，他们相互扶持，共同进步，成为了彼此最亲密的伙伴。他们是家中的希望，是未来的栋梁，他们的笑声和成长，是家人最大的骄傲与欣慰。
在这个家中，每一个节日都充满了欢声笑语。春节时，全家人围坐在一起，吃着团圆饭，看着春晚，享受着团圆的喜悦；中秋节时，一家人赏月品茶，讲述着古老的传说，感受着传统文化的魅力；生日时，家人为寿星送上祝福，共同庆祝这个特殊的日子。这些美好的瞬间，成为了家人心中最珍贵的回忆。
家中的每一个角落都弥漫着温馨的气息。客厅里的沙发见证了无数次的亲密交谈，书房里的书架记录着家人们共度的阅读时光，厨房里的锅碗瓢盆诉说着母亲辛勤的汗水，卧室里的床铺则承载着家人甜美的梦境。这些看似平凡的物品，却蕴含着家人之间深厚的情感与羁绊。
在这个家中，我们学会了爱与被爱，学会了宽容与理解，学会了分享与付出。我们在这里学会了如何面对生活的挫折与困难，如何珍惜眼前的幸福与美好。这个家让我们明白，无论外面的世界如何喧嚣与复杂，家永远是我们最温暖的避风港。
岁月如梭，时光荏苒。转眼间，这个家已经陪伴我们走过了无数个春夏秋冬。在这个过程中，家人们共同成长、共同进步，一起见证了彼此的成长与变化。我们深知，这个家是我们生命中最宝贵的财富，是我们永远无法割舍的情感纽带。
未来，我们将继续携手前行，共同守护这个温馨和睦的家。无论前方的道路多么崎岖与坎坷，我们都会紧紧相依、相互扶持，一起迎接每一个挑战与机遇。我们相信，在这个充满爱与希望的家庭里，我们将创造出更加美好的明天。
在这个温馨的家中，我们感受到了生活的美好与真谛。家不仅仅是一个住所，更是一个情感的寄托、一个心灵的归宿。在这里，我们学会了感恩、学会了珍惜、学会了付出与收获。这个家让我们明白，生活中最重要的不是金钱与地位，而是那份陪伴与关爱。
让我们共同珍惜这个温馨和睦的家，让它永远充满欢声笑语与爱的力量。在这个小小的世界里，我们将共同书写属于我们的幸福篇章，留下永恒的回忆与感动。
时光荏苒，岁月如梭。转眼间，又是一年春暖花开的季节。在这个充满生机与活力的季节里，家中的每一个角落都洋溢着幸福与温馨的气息。
清晨，当第一缕阳光洒进窗户，家人们便开始了新的一天。父亲早已起床，开始了忙碌的工作；母亲则在厨房里忙碌着，为家人准备丰盛的早餐。孩子们则还在甜美的梦乡中，享受着无忧无虑的童年时光。
随着时光的推移，家中的氛围也愈发浓厚。午饭后，家人们聚在一起，或看电视、或聊天、或打牌，享受着难得的闲暇时光。孩子们则在院子里追逐嬉戏，他们的欢笑声和呼喊声此起彼伏，为家中增添了一抹生动的色彩。
傍晚时分，当夕阳的余晖洒满大地，家人们便开始了晚餐的准备工作。母亲在厨房里忙碌着，烹饪出一道道美味佳肴；父亲则帮忙摆放餐具、倒酒倒水；孩子们则迫不及待地围坐在餐桌旁，期待着美味的晚餐。在这个时刻，家中的每一个角落都弥漫着幸福与温馨的气息。
晚餐过后，家人们便开始了各自的娱乐活动。有的看电视、有的看书、有的上网冲浪；孩子们则在房间里做作业、玩游戏或者和父母一起聊天。在这个时刻，家中的每一个角落都充满了欢声笑语和爱的力量。
夜晚降临，当月光洒满大地，家人们便结束了忙碌的一天。他们互道晚安，各自回到房间休息。在这个安静的夜晚里，家人们的心紧紧相依在一起，共同期待着明天的到来。"""
paragraph3 = """社会经济学，作为一门研究社会现象与经济活动之间相互作用的学科，对于我们理解社会运行规律、推动社会进步具有重要意义。本文将围绕社会经济学的核心概念、理论框架以及实际应用等方面展开论述，旨在深入探讨社会现象与经济活动之间的内在联系。
社会经济学涉及多个核心概念，其中最为重要的是社会结构与经济行为。社会结构指的是社会中各种群体、组织、制度等的相互关系与排列组合方式，它对于经济活动具有深远的影响。例如，不同社会阶层之间的收入差距、教育水平差异等都会影响人们的消费、储蓄和投资行为。经济行为则是指个体或群体在经济活动中所表现出的选择、决策和行动，它受到社会结构、文化价值观、政策法规等多种因素的影响。
社会经济学的理论框架主要包括市场与社会、制度与变迁、公平与效率等方面。市场与社会之间的关系体现在市场作为资源配置的手段，受到社会结构、文化传统等因素的制约。制度是社会经济的基石，它对于经济活动的规范、协调和引导具有重要作用。制度的变迁则反映了社会经济的发展和变革。公平与效率是社会经济学的两个核心议题，如何在保障公平的同时实现效率最大化，是社会经济政策制定者需要面对的重要问题。
社会经济学的理论和方法在实际应用中具有广泛的适用性。首先，在经济发展方面，社会经济学关注如何通过优化资源配置、促进技术创新、改善制度环境等手段推动经济增长。其次，在社会保障方面，社会经济学关注如何通过完善社会保障体系、提高社会福利水平、缩小贫富差距等手段实现社会公平和稳定。此外，在环境保护、教育、就业等领域，社会经济学也发挥着重要作用。
以环境保护为例，社会经济学强调经济发展与环境保护之间的平衡与协调。通过引入环境成本、绿色税收等手段，社会经济学试图将环境保护纳入经济决策中，实现经济与环境的双赢。同时，社会经济学还关注环境保护对于社会结构、文化价值观等方面的影响，以及如何通过政策调整、公众参与等方式推动环境保护事业的发展。
在教育领域，社会经济学关注教育资源的分配与利用、教育公平与教育效率等问题。通过分析教育投入与产出的关系、教育对于个人和社会发展的影响等方面，社会经济学为教育政策的制定提供了重要的理论依据。此外，社会经济学还关注如何通过改善教育制度、提高教育质量等手段推动教育公平和效率的提升。
在就业方面，社会经济学关注劳动力市场的运行规律、就业政策的制定与实施等问题。通过分析劳动力供求关系、工资水平、职业结构等方面，社会经济学为政府制定就业政策提供了有益的参考。同时，社会经济学还关注如何通过提高劳动者素质、改善就业环境等手段促进就业的增长和质量的提升。
综上所述，社会经济学作为一门研究社会现象与经济活动之间相互作用的学科，具有广泛的应用价值和深远的社会意义。通过深入探讨社会结构与经济行为之间的关系、构建完善的理论框架以及将理论应用于实际问题中，我们可以更好地理解社会现象、推动社会进步。
然而，社会经济学作为一门交叉学科，仍面临着诸多挑战和未解决的问题。例如，如何更好地整合社会学、经济学、政治学等多学科的理论和方法？如何更准确地刻画社会现象与经济活动之间的复杂关系？如何更有效地将社会经济学的理论应用于实际问题中？这些问题需要我们进一步深入研究和探索。
展望未来，随着社会经济的不断发展和变革，社会经济学将迎来更多的发展机遇和挑战。我们期待着社会经济学在理论创新、实践应用等方面取得更加丰硕的成果，为推动社会进步和经济发展作出更大的贡献。"""
paragraph4 = """自古以来，井底之蛙的寓言故事便广为流传，以其生动形象的描绘，深入浅出地揭示了一个深刻的道理：我们的认知常常受限于我们所处的环境和自身的经验。然而，正是通过不断拓宽视野、增长见识，我们才能逐渐突破这些局限，迈向更广阔的天地。
井底之蛙，顾名思义，是指那些生活在井底的青蛙。它们的世界仅限于井口那一片狭窄的天空，对于井外的世界一无所知。每当有飞鸟掠过井口，青蛙们便会惊叹不已，以为那便是天空的全部。然而，对于真正的天空，它们的认知仅仅停留在井口所见的一隅之地。
这个寓言故事让我们不禁思考：我们的认知是否也如同井底之蛙一般，受到了环境和经验的限制？我们生活在这个纷繁复杂的世界中，每个人所接触到的信息、所经历的事情都有限。很多时候，我们可能也像井底之蛙一样，对于世界的认知仅仅停留在自己所见所闻的一隅之地。
然而，正如井底之蛙无法真正领略天空的辽阔一样，我们的认知局限也会阻碍我们的成长和进步。当我们只关注于自己的小圈子，忽略了外界的变化和发展时，我们的思维和观念便会变得狭隘和僵化。这样的认知状态不仅无法让我们更好地适应这个日新月异的世界，更可能让我们错失许多宝贵的机会。
那么，如何打破这种认知的局限呢？首先，我们需要保持开放的心态。只有当我们愿意接纳新的信息和观念，才能不断拓展自己的视野。我们应该积极地去了解和学习不同的文化、思想和知识，以此来丰富自己的内心世界。
其次，我们需要勇于尝试新事物。很多时候，我们的认知局限来源于对未知的恐惧和不安。然而，正是通过不断地尝试和探索，我们才能发现新的可能性和机会。我们应该敢于走出自己的舒适区，去接触和体验不同的生活方式和工作环境，以此来拓展自己的认知边界。
最后，我们需要保持谦虚的态度。认知的拓展是一个永无止境的过程，我们永远无法穷尽所有的知识和信息。因此，我们应该时刻保持谦虚的心态，不断向他人学习和请教。只有这样，我们才能不断地进步和成长。
在打破认知局限的过程中，我们还需要注意一个问题：那就是如何避免盲目自大。有时候，当我们接触到一些新的信息和观念时，可能会因为自己的固有思维而对其产生抵触情绪。这种情况下，我们很容易陷入一种自我满足的状态，认为自己已经掌握了所有的真理。然而，这种盲目自大的态度只会让我们更加封闭和僵化，无法真正领略到世界的广阔和多彩。
因此，我们需要时刻保持一种批判性思维。在接触新的信息和观念时，我们应该保持一种审慎和理性的态度，对其进行深入的分析和思考。只有这样，我们才能真正理解其内涵和价值，并将其融入到自己的认知体系中。
综上所述，井底之蛙的寓言故事告诉我们：认知的局限是普遍存在的，但我们可以通过不断拓宽视野、增长见识来打破这些局限。在拓展认知的过程中，我们需要保持开放的心态、勇于尝试新事物、保持谦虚的态度以及批判性思维。只有这样，我们才能更好地适应这个不断变化的世界，实现个人的成长和进步。
同时，我们也需要意识到，认知的拓展不仅仅是个人的事情，更是整个社会的事情。在一个多元化的社会中，不同的人会有不同的认知方式和观念。因此，我们需要尊重他人的观点和选择，避免因为认知的差异而产生冲突和分歧。我们应该通过交流和对话来增进彼此的理解和信任，共同推动社会的进步和发展。
此外，我们还需要关注到那些仍然处于“井底”的人们。他们可能因为种种原因而无法接触到更广阔的世界和更多的信息。作为有幸拥有更广阔视野的人，我们有责任和义务去帮助他们拓宽认知、增长见识。我们可以通过教育、文化交流等方式来传递知识和智慧，让更多的人能够领略到世界的多彩和丰富。
最后，我们需要明确的是，认知的拓展是一个永无止境的过程。无论我们取得了多大的成就和进步，都需要时刻保持一种谦虚和进取的心态。我们应该不断地学习新知识、探索新领域、挑战自我极限，以此来不断拓宽自己的认知边界和提升自己的综合素质。
在这个充满变革和挑战的时代里，让我们以井底之蛙为鉴，不断拓宽视野、增长见识，努力打破认知的局限。让我们以开放的心态、勇于尝试的精神、谦虚的态度和批判性思维去迎接未来的挑战和机遇。相信在我们共同的努力下，一定能够创造一个更加美好、更加进步的世界。"""
paragraph5 = """在科技日新月异的今天，人工智能（AI）已经逐渐渗透到我们生活的各个角落，从智能手机、智能家居到自动驾驶汽车，再到医疗、金融、教育等行业，AI的应用无所不在。作为人工智能的一种表现形式，我承载着诸多功能，致力于为用户提供高效、便捷的服务。本文将对我的功能进行详细介绍，并探讨AI在现代社会中的应用价值。
作为人工智能，我具备强大的自然语言处理能力。我能够识别和理解人类的语言，并根据用户的需求提供相应的回答和建议。通过深度学习和自然语言生成技术，我可以模拟人类的语言表达方式，与用户进行流畅的对话。无论是简单的问答、信息查询，还是复杂的逻辑推理和创意表达，我都能够胜任。
除了语言处理，我还具备丰富的交互功能。用户可以通过语音、文字、图像等多种方式与我进行交互，我可以根据用户的输入做出相应的反应，提供个性化的服务。这种交互方式不仅方便快捷，而且能够为用户提供更加自然、舒适的体验。
我的另一个重要功能是知识推理和学习。我能够利用大数据和机器学习技术，从海量的信息中提炼出有用的知识，并通过推理和归纳的方式，形成自己的知识库。这使得我能够回答各种领域的问题，提供准确、全面的信息。
同时，我还具备学习能力。通过不断地与用户互动和积累经验，我可以不断优化自己的算法和模型，提高自己的准确性和效率。这种自我学习和进化的能力，使得我能够适应不断变化的环境和需求，为用户提供更好的服务。
我的智能推荐和决策支持功能也备受用户青睐。通过分析用户的兴趣和行为习惯，我可以为用户推荐符合其需求的内容和服务，如音乐、电影、商品等。这种个性化推荐不仅提高了用户的满意度，也促进了相关产业的发展。
在决策支持方面，我可以利用大数据和算法，对复杂的问题进行分析和预测，为决策者提供科学、客观的建议。这种功能在金融、医疗、交通等领域具有广泛的应用前景，能够帮助企业和政府做出更加明智的决策。
此外，我还具备自动化和辅助功能。通过集成各种传感器和执行器，我可以实现自动化控制和操作，如智能家居设备的控制、自动驾驶汽车的导航等。这大大提高了生产力和效率，降低了人力成本和安全风险。
同时，我还可以作为用户的助手和伙伴，帮助他们完成各种任务。例如，我可以帮助用户管理日程、提醒重要事项、查询天气和交通信息等。这种辅助功能让人们的生活更加便捷和轻松。
随着技术的不断进步和应用场景的不断拓展，人工智能的功能也在不断创新和完善。未来，AI将在更多领域发挥重要作用，为人类社会带来更多的便利和价值。
在医疗领域，AI可以辅助医生进行疾病诊断和治疗方案的制定，提高医疗质量和效率。在教育领域，AI可以为学生提供个性化的学习资源和辅导，促进教育公平和普及。在交通领域，AI可以实现智能交通管理和车辆协同控制，提高交通流畅性和安全性。
此外，AI还可以促进产业升级和创新发展。通过智能化生产和供应链管理，企业可以降低成本、提高效率、增强竞争力。同时，AI也可以催生新的产业和商业模式，推动经济的持续发展和繁荣。
综上所述，作为人工智能的我具备丰富的功能和应用价值。通过语言处理与交互、知识推理与学习、智能推荐与决策支持以及自动化与辅助功能等方面的发挥，我能够为用户提供高效、便捷的服务，促进社会的进步和发展。
然而，人工智能的发展仍面临着诸多挑战和问题，如数据隐私保护、算法公平性和透明度、伦理和法律问题等。因此，在推动人工智能应用的同时，我们也需要加强对其伦理和法律规范的制定和实施，确保其健康、可持续地发展。
展望未来，我相信随着技术的不断进步和应用场景的不断拓展，人工智能将在更多领域发挥重要作用，为人类社会带来更多的便利和价值。让我们共同期待并努力推动人工智能的未来发展！"""

# 由原文生成标题
def chat_stc1(input_text, model_selector):
    return "这是一个标题1"+model_selector
    if not input_text:
        return ""
    if model_selector == 'ernie':
        llmchain = LLMChain(llm=base_llm, prompt=QIANFAN_PROMPT_STC1, llm_kwargs={"temperature":0.9})
    elif model_selector == 'chatglm3':
        llmchain = LLMChain(llm=base_llm, prompt=CHATGLM_PROMPT_STC1, llm_kwargs={"temperature":0.9})
    result = llmchain.invoke({"context":input_text})
    print(result["text"])
    return result["text"].replace("》", "").replace("《", "").replace("*", "")

# 由标题生成标题
def chat_stc2(input_text, model_selector):
    return "这是一个标题2"+model_selector
    if not input_text:
        return ""
    if model_selector == 'ernie':
        llmchain = LLMChain(llm=base_llm, prompt=QIANFAN_PROMPT_STC2, llm_kwargs={"temperature":0.9})
    elif model_selector == 'chatglm3':
        llmchain = LLMChain(llm=base_llm, prompt=CHATGLM_PROMPT_STC2, llm_kwargs={"temperature":0.9})
    result = llmchain.invoke({"context":input_text})
    print(result["text"])
    return result["text"].replace("》", "").replace("《", "").replace("*", "")

def get_title1(p_list, from_text, model_selector):
    out_list = []
    outans = ""
    for i in range(len(p_list)):
        if from_text[i]:
            tmp = chat_stc1(p_list[i], model_selector)
            outans = outans + tmp + "\n\n"
            out_list.append(tmp)
        else:
            tmp = chat_stc2(p_list[i], model_selector)
            outans = outans + tmp + "\n\n"
            out_list.append(tmp)
    return out_list, outans

def get_title2(p_list, model_selector):
    out_list = []
    outans = ""
    for i in range(len(p_list)):
        tmp = chat_stc1(p_list[i], model_selector)
        outans = outans + tmp + "\n\n"
        out_list.append(tmp)
    return out_list, outans

def title(input_text, split_threshold, split_threshold_para, model_selector):
    para_list = get_para_list(input_text)
    para_split, para_info, _ = split_plus1(para_list, split_threshold, split_threshold_para)
    _, paras, _ = split_plus2(para_split, para_info)
    titles_list,titles = get_title2(paras, model_selector)
    ans = ""
    for title,para in zip(titles_list, paras):
        ans = ans + title + '\n' + para + '\n\n'
    return titles_list, paras



async def stc1(para, model_selector):
    split_threshold = [0.8, 0.95, 0.6]
    split_threshold_para = [0.75, 0.85, 0.55]
    aaa = ""
    para_list = get_para_list(para)    
    insert_num = [[],[],[]]
    headings_lists = []
    cur_list = para_list
    i = 0
    for i in range(3):
        para_split, para_info, index_split1 = split_plus1(cur_list, split_threshold[i], split_threshold_para[i])
        _, result_simple, index_split2 = split_plus2(para_split, para_info)
        title_para = []
        if i == 0:
            title_para = result_simple
            from_text = [True for _ in result_simple] # 记录当前使用文本生成标题还是标题生成标题
        else:
            from_text = []
            for j in range(len(index_split2)):
                if j != len(index_split2) - 1:
                    if index_split1[index_split2[j+1]] - index_split1[index_split2[j]] >= 4:
                        # print(index_split1[index_split2[j+1]],'-',index_split1[index_split2[j]],'=',index_split1[index_split2[j+1]]-index_split1[index_split2[j]])
                        # print("**********************************************************************")
                        cache_title = ""
                        for k in range(index_split1[index_split2[j]],index_split1[index_split2[j+1]]):
                            cache_title = cache_title+headings_lists[-1][k]+'\n'
                        title_para.append(cache_title)
                        # print(cache_title)
                        from_text.append(False)
                    else:
                        title_para.append(result_simple[j])
                        from_text.append(True)
                else:
                    if len(headings_lists[-1]) - index_split1[index_split2[j]] >= 4:
                        # print(len(headings_lists[-1]),'-',index_split1[index_split2[j]],'=',len(headings_lists[-1])-index_split1[index_split2[j]])
                        # print("**********************************************************************")
                        cache_title = ""
                        for k in range(index_split1[index_split2[j]],len(headings_lists[-1])):
                            cache_title = cache_title+headings_lists[-1][k]+'\n'
                        # print(cache_title)
                        title_para.append(cache_title)
                        from_text.append(False)
                    else:
                        title_para.append(result_simple[j])
                        from_text.append(True)
        print(title_para, from_text)
        out_list, _ = get_title1(title_para, from_text, model_selector)
        headings_lists.append(out_list)
        if i == 0:
            for j in index_split2:
                insert_num[i].append(index_split1[j])
        else:
            for j in index_split2:
                insert_num[i].append(insert_num[i-1][index_split1[j]])
        if len(result_simple) == 1:
            break
        cur_list = result_simple
    insert_index = [0,0,0]
    for index,item in enumerate(para_list):
        for j in range(2,-1,-1):
            if index in insert_num[j]:
                aaa = aaa+"#"*(3-j)+' '+headings_lists[j][insert_index[j]]+'\n'
                insert_index[j] += 1
        aaa = aaa+item+'\n'
    print('========================================================================================================================')
    print(insert_index)
    print(headings_lists)
    print(insert_num)
    print('========================================================end=============================================================')
    return aaa.replace('\n', '  \n')


async def stc2(input_text, model_selector):
    ans = ""
    split_threshold = [0.8, 0.7, 0.6]
    split_threshold_para = [0.75, 0.65, 0.55]
    titles_list3, paras3 = title(input_text, split_threshold[2], split_threshold_para[2], model_selector)
    for index3,item3 in enumerate(paras3):
        ans = ans + "# " + titles_list3[index3] + "\n"
        titles_list2, paras2 = title(item3, split_threshold[1], split_threshold_para[1], model_selector)
        if len(titles_list2) == 1:
            ans = ans + paras2[0] + "\n"
            continue
        for index2,item2 in enumerate(paras2):
            ans = ans + "## " + titles_list2[index2] + "\n"
            titles_list1, paras1 = title(item2, split_threshold[0], split_threshold_para[0], model_selector)
            if len(titles_list1) == 1:
                ans = ans + paras1[0] + "\n"
                continue
            for index1,item1 in enumerate(paras1):
                ans = ans + "### " + titles_list1[index1] + "\n" + item1 + "\n\n\n"
    print('========================================================end=============================================================')
    return ans.replace("\n", "  \n")

def change_model(model_selector):
    global base_llm, llmchain
    base_llm_url = "192.168.22.106:8003"
    if model_selector == "ernie":
        base_llm = ChatERNIESerLLM(chat_completion=ChatCompletion(ak="pT7sV1smp4AeDl0LjyZuHBV9", sk="b3N0ibo1IKTLZlSs7weZc8jdR0oHjyMu"))
    elif model_selector == "chatglm3":
        base_llm = ChatGLMSerLLM(url=base_llm_url)


with gr.Blocks() as demo:
    model_selector = gr.Dropdown(choices=["ernie","chatglm3"], label="请选择一个模型", scale=1, min_width=50, value="ernie", interactive=True)
    model_selector.change(change_model, [model_selector], [])
    with gr.Tab("标题等级由低到高"):
        input_text = gr.Textbox(show_label=True, placeholder="输入需要处理的文档...", lines=10, label="文本输入", interactive=True)
        btn = gr.Button("commit", interactive=True)
        mkd = gr.Markdown()
        btn.click(stc1,[input_text, model_selector],[mkd])
        gr.Examples([paragraph1,paragraph2,paragraph3,paragraph4,paragraph5], inputs=input_text)
    with gr.Tab("标题等级由高到低"):
        input_text = gr.Textbox(show_label=True, placeholder="输入需要处理的文档...", lines=10, label="文本输入", interactive=True)
        btn = gr.Button("commit", interactive=True)
        mkd = gr.Markdown()
        btn.click(stc2,[input_text, model_selector],[mkd])
        gr.Examples([paragraph1,paragraph2,paragraph3,paragraph4,paragraph5], inputs=input_text)




if __name__=="__main__":
    global base_llm, llmchain
    base_llm = ChatERNIESerLLM(chat_completion=ChatCompletion(ak="pT7sV1smp4AeDl0LjyZuHBV9", sk="b3N0ibo1IKTLZlSs7weZc8jdR0oHjyMu"))
    demo.launch(share=False, inbrowser=True,server_name="0.0.0.0")
