# -*- coding: utf-8 -*-
import os, sys
sys.path.append("../..") 

from llm.chatglm import ChatGLMSerLLM
from langchain.chains import LLMChain
from langchain.prompts import PromptTemplate

chatglm_prompt = """请使用关键词："{context}" 造几个句子，认真理解关键词想要表达的意思，句子要求语句通顺，句式正确，按照1、2、3列表输出句子。"""
CHATGLM_PROMPT = PromptTemplate(input_variables=["context"],template=chatglm_prompt)

base_llm=ChatGLMSerLLM(url="http://192.168.22.106:8003")
chose_llm = LLMChain(llm=base_llm, prompt=CHATGLM_PROMPT)
# keywords = ["狗日的","狗娘养","全家死绝","人渣","杀b","风骚"]
# for keyword in keywords:
#     result = chose_llm.invoke({"context":keyword})
#     print(result["context"])
#     print(result["text"])


from langchain.embeddings.huggingface import (
    HuggingFaceEmbeddings,
)
from sklearn.metrics.pairwise import cosine_similarity
import numpy as np
import gradio as gr

para = '''经济的开放是一把“双刃剑”。 一方面，它为经济提供了许多封闭条件下不具备的有利条件；另一方面它也对经济的稳定与发展造成了很大的冲击。在开放条件下，经济政策的目标不再只是维持内部总需求和总供给的平衡，而且还要尽可能维持国际收支平衡。然而，经济政策在内部均衡和外部平衡这两个目标之间存在着冲突的可能。
进一步地说，在封闭经济下，经济增长、充分就业与价格稳定是政府追求的主要经济目标。这三个目标本身就存在着冲突。例如，失业率与通货膨胀之间可能存在着相互替换关系，经济增长往往也会带来通货膨胀。封闭经济中政策调控的主要课题在于协调这三者的冲突，确定并实现这三者的合理组合。在开放经济中，政府的政策目标发生了改变，国际收支成为宏观调控所关注的目标之一，宏观经济在封闭条件下的主要目标与国际收支这一新的目标之间的冲突成为经济面临的突出问题，某一个目标的实现可能会导致另一个目标的恶化，政策的选择和搭配也就有了更高的要求。
按照第二章介绍的国际收支吸收论，国际收支(外部平衡)取决于国民收入和国内吸收的大小。当国民收入大于总吸收时，国际收支为顺差；当国民收入小于总吸收时，国际收支为逆差；当国民收入等于总吸收时，国民收支为平衡。
然而，国民收入和国内吸收孰高孰低是一国内部经济均衡的要求所决定的：在一国经济高速发展的阶段，国内需求旺盛，投资需求高，国内产出提高的速度跟不上需求(支出)增加的速度。如果要满足国内需求，实现内部均衡，就会发生净进口，导致国际收支逆差。反之，在经济发展的成熟阶段，国内产出水平很高，但经济增长缓慢，需求(尤其是投资需求)较低，产出不能被国内完全吸收，要依靠净出口来弥补需求的不足，导致国际收支顺差。也就是说，随着一国经济发展阶段的不同，内部均衡和外部平衡可能会产生冲突。
英国经济学家米德(J.Meade)   于1951在其名著《国际收支》中最早提出了固定汇率制下经济政策内部均衡目标和外部平衡目标的冲突问题，这一观点被称作米德冲突(Meade's    Conflict)。他指出，在汇率固定不变时，政府只能主要运用影响社会总需求的政策来调节内部均衡和外部平衡。这样，在开放经济运行的特定区间便会出现内部均衡和外部平衡难以兼顾的情形。在开放条件下，经济可能面临着如表4-2所示的内外经济状况的组合(假定失业与通货膨胀是两种独立的情况、外部平衡就是经常账户平衡)。'''

para2 = '''区域性优惠贸易协定项下出口货物原产地证明书(以下简称优惠原产地证)是有区域 性优惠贸易协定国家官方机构签发的享受成员国关税互惠减免待遇的官方凭证，是企业出口 产品通向国际市场的“金钥匙”和“有价证券”。凭借优惠原产地证，企业出口产品可以享 受优惠关税甚至零关税的待遇，从而有效降低产品出口成本，提高产品的国际竞争力。
自加入WTO 至今，我国已同有关国家和地区签署了如下的区域性优惠贸易协定，包括 《内地与港澳更紧密经贸关系安排 (CEPA)》  《亚太贸易协定》《中国一东盟自贸协定》《中 国一巴基斯坦自贸协定》 《中国一智利自贸协定》 《中国一新西兰自贸协定》 《中国一新加 坡自贸协定》 《中国一哥斯达黎加自贸协定》 《中国一秘鲁自贸协定》 《中国一瑞士自贸协 定》《中国—冰岛自贸协定》 《中国一韩国自贸协定》 《中国一澳大利亚自贸协定》海峡两 岸经济合作框架协议 (ECFA)  等，还有更多的自由贸易区正在谈判或研究之中。
目前贸促会受理以下地区的优惠原产地证  《亚太贸易协定》目的国：印度、韩国、孟  加拉、斯里兰卡、老挝 《中国一新西兰自由贸易协定》目的国：新西兰；  《中国一新加坡 自由贸易协定》目的国：新加坡 《中国一秘鲁自由贸易协定》目的国：秘鲁；海峡两岸经 济合作框架协议 (ECFA)  目的地：中国台湾 《中国一瑞士自由贸易协定》目的国：瑞士； 《中国 —冰岛自由贸易协定》目的国：冰岛  《中国一韩国自由贸易协定》目的国：韩国； 《中国一澳大利亚自由贸易协定》目的国：澳大利亚。
FORM  B证书是根据《亚太贸易协定》 (FIRST  AGREEMENT  ON  TRADE  NEGOTIATIONS AMONG DEVELOPING MEMBER COUNTRIES OF THE ECONOMIC AND SOCIAL COMMISSION FOR ASIA AND THE PACIFIC) 原产地规则的要求签发的前身为《曼谷协定》,是在签订协定 的成员国之间就特定产品享受互惠减免关税待遇(跟非互惠的FORM  A证书不同) 的官方 原产地证明文件。
FORM  B证书的签订依据为《亚太贸易协定》原产地规则和《亚太贸易协定原产地证 书签发和核查程序》。
可签发FORM  B 证书的国家为：中国、印度、斯里兰卡、孟加拉国、老挝和韩国(《亚 太贸易协定》成员国)。
如货物为完全原产，填写 “A”。如货物含进口成分，非国产价值成分<55%,填写字母   “B”加原产于非成员国或原产地不明的材料、部件或产品的总货值占出口产品离岸价的百分   比，例如( ‘B”40%)。  如货物含进口成分，国产及成员国累计价值成分≥60%,填写 “C” 加原产于成员国的累计含量的总值与出口产品离岸价的百分比，例如(  “℃”65%)。符合特  定原产地标准的产品，填写字母 “D”(该项主要针对不发达国家出口申报的产品)。
注意《亚太贸易协定》原产地证书申请时间不得超过货物出运后3个工作日。
FORM  E证书是根据《中华人民共和国与东南亚国家联盟全面经济合作框架协议》的要 求签发的、在签订协定的成员国之间就特定产品享受互惠减免关税待遇的(跟非互惠的 FORM  A证书不同)官方原产地证明文件。
FORME  证书的签订依据为《中国一东盟自由贸易区原产地规则》和《中国一东盟自170. 国际贸易单证实务由贸易区原产地规则签证操作程序》。
可签发FORME  证书的国家为：中国、老挝、越南、泰国、缅甸、柬埔寨、菲律宾、文 莱、印度尼西亚、马来西亚和新加坡(东盟成员国)。
如货物完全原产，填写“×”。如货物含进口成分，其国产价值成分≥40%,填写国产 价值的百分比，例如   “45%”。如货物含进口成分，中国一东盟自贸区累计价值成分≥ 40%,填写该累计价值的百分比，例如 “45%”。
注意：证书为一正三副， 一三联客户，二联商检留存，四联企业留存。
FORMP 证书是根据《中华人民共和国政府与巴基斯坦伊斯兰共和国政府关于自由贸易 协定早期收获计划的协议》(简称《早期收获协议》)及其项下《中国一巴基斯坦自由贸易 区原产地规则》的要求签发的在中国和巴基斯坦之间就特定产品享受互惠减免关税待遇的 (跟非互惠的FORMA  证书不同)官方原产地证明文件。
FORMP 证书的签订依据为《中国一巴基斯坦自由贸易区原产地规则》和《中国一巴基 斯坦自由贸易区原产地规则签证操作程序》。
可签发FORMP  证书的国家为中国和巴基斯坦。中国产品出口到巴基斯坦，中国出口商 向各地出入境检验检疫机构申请签发FORMP  证书，巴基斯坦给予FORM P证书项下货物关 税优惠待遇；巴基斯坦产品出口到中国，巴基斯坦出口商向巴基斯坦有关部门申请签发 FORMP  证书，中国给予FORMP  证书项下货物关税优惠待遇。这是互惠的。
如货物为完全原产，填写“P”; 如货物含进口成分，国产价值成分≥45%,填写国产价 值的百分比，例如   "40%";如货物含进口成分，中国一巴基斯坦自贸区累计价值成分≥ 40%,填写该累计价值的百分比，例如  “45%”;产品符合特定原产地标准，填写 “PSR”。
注意：出运后15日内办理。
FORMF 证书是根据《中国一智利自由贸易协定》及其项下《中国一智利自贸区原产地 规则》的要求签发的，在中国和智利之间就特定产品享受互惠减免关税待遇的(跟非互惠 的 FORM  A证书不同)官方原产地证明文件。
FORMF  证书的签订依据为《中国一智利自贸区原产地规则》和《中国一智利自由贸易 区原产地规则签证操作程序》。
可签发FORMF  证书的国家为中国和智利。中国产品出口到智利，中国出口商向各地出 入境检验检疫机构申请签发FORMF  证书，智利给予FORMF  证书项下货物关税优惠待遇； 智利产品出口到中国，智利出口商向智利有关部门申请签发FORMF  证书，中国给予FORM  F 证书项下货物关税优惠待遇。这是互惠的。
如货物为完全原产，填写 “P”; 如货物为含进口成分，区域价值成分≥40%,填写 “RVC"; 产品符合特定原产地标准，填写 “PSR”并附《中智自由贸易区产品特定原产地 标准》(简称 “PSR”清单)。
注意：证书的申办时间应在货物出口前或出口后的30天内；货物出口30天后，签证机 构不再接受证书的签发申请。
FORM N 证书是根据《中华人民共和国政府和新西兰政府自由贸易协定》和《中华人第五章 其他出口结汇单证.171.民共和国政府和新西兰政府自由贸易协定项下进出口货物原产地管理办法》的要求签发的、 在中国和新西兰之间就特定产品享受互惠减免关税待遇的(跟非互惠的FORM  A证书不同)  官方原产地证明文件。《中华人民共和国政府和新西兰政府自由贸易协定》于2008年4月7  日正式签署，这是中国与发达国家签署的第一个自由贸易协定。
可签发FORM  N 证书的国家为中国和新西兰。中国产品出口到新西兰，中国出口商向 各地出入境检验检疫机构申请签发FORM  N 证书，新西兰给予FORM  N证书项下货物关税 优惠待遇；新西兰产品出口到中国，新西兰出口商向新西兰有关部门申请签发 FORM  N 证 书，中国给予FORM  N证书项下货物关税优惠待遇。这是互惠的。
如货物为完全原产，填写 “WO”; 如货物含有进口成分，但完全由已经取得原产资格 的材料或部件生产，填写 “WP”; 产品符合特定原产地标准，填写 “PSR”, 有区域价值成 分要求的，应注明百分比，例如 “PSR”60%。
注意：证书申办时间：应在货物出口前或当天申请办理，中国一新西兰证书不办理后 发，不倒签。
FORMX  证书是根据 《中华人民共和国政府和新加坡共和国政府自由贸易协定》和 《中华人民共和国政府和新加坡共和国政府自由贸易协定项下进出口货物原产地管理办法》 的要求签发的，在中国和新加坡之间就特定产品享受互惠减免关税待遇的(跟非互惠的 FORM  A证书不同)官方原产地证明文件。
FORM  X 证书的签订依据为《中国一新加坡自贸协定原产地规则》及其相关的原产地签 证操作程序。
可签发FORM  X 证书的国家为中国和新加坡。中国产品出口到新加坡，中国出口商向 各地出入境检验检疫机构申请签发 FORM  X 证书，新加坡给予 FORM  X 证书项下货物关税 优惠待遇；新加坡产品出口到中国，新加坡出口商向新加坡有关部门申请签发 FORM  X 证 书，中国给予FORM  X证书项下货物关税优惠待遇。这是互惠的。
中国一新加坡自贸区原产地规则规定：在出口方完全获得的产品，填写 “P”; 区域价 值成分≥40%的产品，填写 “RVC"; 符合产品特定原产地规则的产品，填写 “PSR”。
注意：应在提单日期前申报，不办理后发证书。
证书英文名称： Certificate of Origin Form for China-Peru FTA。
中国一秘鲁FTA 证书是根据《中国一秘鲁自由贸易协定》及其项下《中国一秘鲁自贸 区原产地规则》的要求签发的、在中国和秘鲁之间就特定产品享受互惠减免关税待遇的 (跟非互惠的FORM  A证书不同)官方原产地证明文件。
中国一秘鲁FTA 证书的签订依据为《中国一秘鲁自贸区原产地规则》及与原产地相关 的签证操作程序。
可签发中国一秘鲁 FTA 证书的国家为中国和秘鲁。中国产品出口到秘鲁，中国出口商 向各地出入境检验检疫机构申请签发中国一秘鲁 FTA 证书，秘鲁给予中国一秘鲁FTA 证书 项下货物关税优惠待遇；秘鲁产品出口到中国，秘鲁出口商向秘鲁有关部门申请签发中国一 秘鲁FTA 证书，中国给予中国一秘鲁FTA 证书项下货物关税优惠待遇。这是互惠的。
FORML  证书是根据《中国一哥斯达黎加自由贸易协定》及其项下 《中国一哥斯达黎加国际贸易单证实务自贸区原产地规则》的要求签发的、在中国和哥斯达黎加之间就特定产品享受互惠减免关 税待遇的(跟非互惠的FORM  A证书不同)官方原产地证明文件。
FORML  证书的签订依据为《中国一哥斯达黎加自贸区原产地规则》及与原产地相关的 签证操作程序。
可签发FORML  证书的国家为中国和哥斯达黎加。中国产品出口到哥斯达黎加，中国出 口商向各地出入境检验检疫机构申请签发 FORML  证书，哥斯达黎加给予FORM  L证书项下 货物关税优惠待遇；哥斯达黎加产品出口到中国，哥斯达黎加出口商向哥斯达黎加有关部门 申请签发 FORML  证书，中国给予FORML  证书项下货物关税优惠待遇。这是互惠的。
FORMS  证书是根据《中华人民共和国和瑞士联邦自由贸易协定》及其相关规定的要求 签发的、在中国和瑞士之间就特定产品享受互惠减免关税待遇的(跟非互惠的 FORM  A 证 书不同)官方原产地证明文件。
FORMS  证书的签订依据为《中国一瑞士自由贸易区原产地规则》及其相关的原产地签 证操作程序。《中华人民共和国和瑞士联邦自由贸易协定》于2014年7月1日起施行。
可签发FORMS  证书的国家为中国和瑞士。中国产品出口到瑞士，中国出口商向各地出 入境检验检疫机构申请签发FORMS  证书，瑞士给予FORMS  证书项下货物关税优惠待遇； 瑞士产品出口到中国，瑞士出口商向瑞士有关部门申请签发FORMS  证书，中国给予FORM  S 证书项下货物关税优惠待遇。这是互惠的。
《海峡两岸经济合作框架协议》 (ECFA)  是台湾与大陆自2009年年中开始，经过多次 商谈达成的一项重要协议，于2010年6月29日签署，其项下货物贸易早期收获清单于2011 年 1 月 1 日起付诸实施，出口到台湾的货物将获得关税减免的优惠。
列入清单的约800项产品将逐步降关税，三年内全部降为零，包括大陆对台湾开放的产 品500多项，台湾批准大陆的产品5大类267项，含石化类、机械类、纺织类、运输类等产品。海峡两岸经济合作框架协议(英文为 ECONOMIC    COOPERATION    FRAMEWORKAGREEMENT,ECFA;     台湾方面的繁体版本称为海峡两岸经济合作架构协议),原称为两岸 综合性经济合作协定或称两岸综合经济合作协定(英文简称 CECA,  即 COMPREHENSIVEECONOMIC COOPERATION AGREEMENT)。
中国出口到韩国的原产地证， 一般叫作韩国原产地证，英文名为 CERTIFICATE  OF ORIGIN  FORM  FOR  CHINA-KOREA  FTA, 也可叫作韩国FTA 产地证FORM  K, 简称中韩原 产地证，是中国出口到韩国需要办理的原产地证之一。具体是指货物经中国出口至韩国时需 要向中国国际贸易促进委员会或中国出入境检验检疫局申请签发办理的一种用来证明所出口 的货物原产地或产品制造地为中国的证明文书。中韩 FTA 原产地证于2015年12月20日正 式生效并实施第一次降税，并于2016年1月1日实施第二次降税。而自2005年12月20日 起，凡是货物出口至韩国的出口企业均可向中国各地的出入境检验检疫机构申请签发中韩自 贸协定原产地证书；且只要是出口商在货物出口韩国时，向进口国海关出示由中国出入境检 验检疫局所办理的韩国原产地，其所随附原产地证书的出口货物将按照自贸协定可在韩国享 受优惠关税待遇。目前，货物经中国出口至韩国所需要办理的产地证有以下三种：第五章  其他出口结汇单证173(1) 一般原产地证CO。 从中国出口到韩国的货物在办理产地证时也可以选择办理一般  原产地证CO, 一般原产地证 CO 是全世界任何国家和地区均可以办理的一种原产地证书。 因此，货物出口韩国也可以选择办理一般原产地证CO, 该原产地证是产地证中的一种最基  础、最原始、最原籍的产地证书。但一般原产地证CO 只能作为货物的清关文件使用，相当  于一张货物的“入门票”,是不享有韩国的关税优惠减免待遇的，所以，在办理中国出口到  韩国的原产地证时，最好不要选择办理这种原产地证，但若是国外客户要求办理该产地证， 那么就具体地根据客户的要求来。
(2)亚太原产地证FORM  B。亚太原产地证是货物从中国出口到韩国时可以选择办理的 另外一种原产地证。由于韩国也是亚太地区成员国之一，因此货物从中国出口到韩国，选择 办理亚太原产地证也是一种较好的选择。该原产地证相对于一般原产地证 CO 来说，主要的 优势在于能够享受到进口目标国的关税优惠待遇，且也使货物能够进入韩国这个国家。
(3)韩国原产地证。韩国原产地证是一种区域性优惠原产地证，是中国近期与韩国签  订的一种外贸合作协定，简称中韩自贸协定，是一种专门针对韩国签发的原产地证书，也是  货物从中国出口到韩国时首选的原产地证。韩国原产地证不仅可以使得货物顺利清关，还能  享受到比亚太原产地证所规定的关税优惠更多的优惠待遇。因此，凡是货物出口至韩国时， 最好首先考虑选择办理韩国原产地证，其次才是亚太原产地证。
中国一韩国原产地证明书的签发，限于已公布的《货物贸易协定》项下给予关税优惠 的产品，这些产品必须符合《中国一韩国自由贸易区原产地规则》。
中国一澳大利亚原产地证，全称为《中国一澳大利亚自贸区》优惠原产地证，英文名称 为 CERTIFICATE  OF  ORIGIN  FORM  FOR  CHINA-AUSTRALIA  FREE  TRADE  AGREEMENT, 简 称中澳原产地证或 FORM   AU原产地证。中澳原产地证是根据《中国一澳大利亚自由贸易协 定》签发的、就中澳两国之间互相给予关税减免待遇的官方证明文件。
FORM   AU证书签订依据为《中国一澳大利亚原产地证规则》及其签证操作程序。 《中 国一澳大利亚自贸区》优惠原产地证采用专用证书格式， 一正一副，正本为深棕色，印有 钮索图案底纹，副本为白色。
签证产品 《中国 一澳大利亚原产地证明书》的签发，限于已公布的《货物贸易协定》 项下给予关税优惠的产品，这些产品必须符合《中国一澳大利亚自由贸易区原产地规则》。
请注意，不同种类的产地证出证要求不尽相同，不同的优惠原产地证可能有不同的特定 要求，如果不符合要求，就无法享受关税减免等优惠，所以一定要重视。'''

embedding_path = "C:\\Users\\15663\\AI\\models\\bge-large-zh-v1.5"
embedding = HuggingFaceEmbeddings(model_name=embedding_path)

def split_plus(para,split_threshold,split_threshold_para,marge_threshold_para=0):
    # 分割段落
    o_para_list = para.split("\n")
    # 处理空行，长度小于20的行自动分到下一段
    para_list = []
    for index,item in enumerate(o_para_list):
        if len(item.strip()) == 0:
            if len(para_list) == 0:
                para_list.append(item+'\n')
            else:
                para_list[-1] = para_list[-1] + '\n' + item
        elif len(item) <= 20:
            if index+1 < len(o_para_list):
                o_para_list[index+1] = item+"\n"+o_para_list[index+1]
                continue
            else:
                para_list.append(item)
        else:
            para_list.append(item)
    print(para_list)
    if len(para_list) >= 2 and all(char.isspace() for char in para_list[0]):
        tmp_str = para_list[0]
        para_list = para_list[1:]
        para_list[0] = tmp_str+para_list[0]
    # print(para_list)
    # 分割段落
    para_split = []
    # 记录每段插入相似度信息和位置   [{"offset":0,"similarity":[0.5,0.5]}"}]
    para_info = []
    # 记录当前段落
    cur_para = para_list[0]
    # 记录当前段落信息
    cur_para_info = []
    cur_para_vec = embedding.embed_query(cur_para)
    cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
    last_centence_vec = cur_para_vec
    for index in range(1,len(para_list)):
        vec = embedding.embed_query(para_list[index])
        vec = np.array(vec)
        vec = vec.reshape(1,-1)
        similarity = cosine_similarity(cur_para_vec,vec)
        similarity2 = cosine_similarity(last_centence_vec,vec)
        if similarity > split_threshold_para or similarity2 > split_threshold:
            cur_para_info.append({"offset":len(cur_para)+1,"similarity":[similarity[0][0],similarity2[0][0]]})
            cur_para += "\n" + para_list[index]
            cur_para_vec = embedding.embed_query(cur_para)
            cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
        else:
            para_split.append(cur_para)
            para_info.append({"para_info":cur_para_info,"para_vec":cur_para_vec})
            cur_para = para_list[index]
            cur_para_info=[{"offset":0,"similarity":[similarity[0][0],similarity2[0][0]]}]
            cur_para_vec = vec
        last_centence_vec = vec
        # print("-----------------para=------", para_list[index])
        # print("----------------vec---------", vec)
        # print(cur_para_vec)
        # print(cur_para_info)
        # print(para_info)
    if len(cur_para)>0:
        para_split.append(cur_para)
        para_info.append({"para_info":cur_para_info,"para_vec":cur_para_vec})
    # 将游离的句子合并到上下段落，根据相似度判断
    result = []
    result_simple = []
    def insert_info(para,info):
        for i in range(len(info)-1,-1,-1):
            para = para[:info[i]["offset"]] + "**与上段落相似 {:.5} 与上句相似 {:.5}**\n".format(info[i]["similarity"][0],info[i]["similarity"][1]) +para[info[i]["offset"]:]
        return para

    cache_para = ""
    cache_para_simple = ""
    last_para_vec = None
    for index in range(len(para_split)):
        # 如果段落不是单独的句子
        if len(para_info[index]["para_info"])>1:
            result.append(cache_para+insert_info(para_split[index],para_info[index]["para_info"]))
            result_simple.append(cache_para_simple+para_split[index])
            cache_para = ""
            cache_para_simple = ""
            last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
        else: # 需要合并
            if index == len(para_split)-1:
                if len(result)>0:
                    result[-1] += "\n"+cache_para+insert_info(para_split[index],para_info[index]["para_info"])
                    result_simple[-1] += "\n"+cache_para_simple+para_split[index]
                else:
                    result.append(cache_para+insert_info(para_split[index],para_info[index]["para_info"]))
                    result_simple.append(cache_para_simple+para_split[index])
                cache_para = ""
                cache_para_simple = ""
                last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
            else:
                if index == 0:
                    cache_para += insert_info(para_split[index],para_info[index]["para_info"]) +"\n"
                    cache_para_simple += para_split[index]+ "\n"
                    # last_para_vec = embedding.embed_query(result_simple[-1])
                else:
                    if last_para_vec is not None:
                        last_similarity = cosine_similarity(para_info[index]["para_vec"],last_para_vec)[0][0]
                        last_para_vec = None
                    else:
                        last_similarity = para_info[index]["para_info"][0]["similarity"][0]
                    next_similarity = cosine_similarity(para_info[index]["para_vec"],para_info[index+1]["para_vec"])
                    if last_similarity > marge_threshold_para or next_similarity > marge_threshold_para or len(para_split[index]) < 50:
                        if last_similarity > next_similarity and len(result)>0:
                            result[-1] += "\n"+cache_para+insert_info(para_split[index],para_info[index]["para_info"])
                            result_simple[-1] += "\n"+cache_para_simple+para_split[index]
                            cache_para = ""
                            cache_para_simple = ""
                            last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
                        else:
                            cache_para += insert_info(para_split[index],para_info[index]["para_info"])+"\n"
                            cache_para_simple += para_split[index]+ "\n"
                            last_para_vec = np.array(embedding.embed_query(cache_para)).reshape(1,-1)
                    else:
                        result.append(cache_para+insert_info(para_split[index],para_info[index]["para_info"]))
                        result_simple.append(cache_para_simple+para_split[index])
                        last_para_vec = np.array(embedding.embed_query(result_simple[-1])).reshape(1,-1)
                        cache_para = ""
                        cache_para_simple = ""
    if len(cache_para)>0:
        result.append(cache_para)
        result_simple.append(cache_para_simple)            
    return result,result_simple    
    
    
    

def split_adapt_both(para,split_threshold,split_threshold_para):
    para_list = para.split("\n")
    avg_len = len(para)//len(para_list)
    para_split = []
    para_split_simple = []
    cur_para = para_list[0]
    cur_para_more = para_list[0]
    cur_para_vec = embedding.embed_query(cur_para)
    cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
    last_centence_vec = cur_para_vec
    for index in range(1,len(para_list)):
        vec = embedding.embed_query(para_list[index])
        vec = np.array(vec)
        vec = vec.reshape(1,-1)
        similarity = cosine_similarity(cur_para_vec,vec)
        similarity2 = cosine_similarity(last_centence_vec,vec)
        if similarity > split_threshold_para or similarity2 > split_threshold:
            cur_para += "\n" + para_list[index]
            cur_para_more += f"\n---------与上段落相似 {similarity[0][0]:.5} 与上句相似 {similarity2[0][0]:.5}---------\n" + para_list[index]
            cur_para_vec = embedding.embed_query(cur_para)
            cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
        else:
            para_split.append(cur_para_more)
            para_split_simple.append(cur_para)
            cur_para = "\n" + para_list[index]
            cur_para_more = f"\n---------与上段落相似 {similarity[0][0]:.5} 与上句相似 {similarity2[0][0]:.5}---------\n" + para_list[index]
            cur_para_vec = vec
        last_centence_vec = vec
    if len(cur_para)>0:
        para_split.append(cur_para_more)
        para_split_simple.append(cur_para)
    result = []
    result_simple = []
    for index in range(len(para_split)):
        if len(para_split[index]) < avg_len*1.5:
            if len(result)>0:
                result[-1] += "\n" + para_split[index]
                result_simple[-1] += "\n" + para_split_simple[index]
            else:
                result.append(para_split[index])
                result_simple.append(para_split_simple[index])
        else:
            result.append(para_split[index])
            result_simple.append(para_split_simple[index])
    return result,result_simple
def split_adapt(para,split_threshold):
    para_list = para.split("\n")
    para_split = []
    para_split_simple = []
    cur_para = para_list[0]
    cur_para_simple = para_list[0]
    cur_para_vec = embedding.embed_query(cur_para)
    cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
    for index in range(1,len(para_list)):
        vec = embedding.embed_query(para_list[index])
        vec = np.array(vec)
        vec = vec.reshape(1,-1)
        similarity = cosine_similarity(cur_para_vec,vec)
        if similarity > split_threshold:
            cur_para += f"\n{similarity[0][0]:.5}\n" + para_list[index]
            cur_para_simple += "\n" + para_list[index]
            cur_para_vec = embedding.embed_query(cur_para)
            cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
        else:
            para_split.append(cur_para)
            para_split_simple.append(cur_para_simple)
            cur_para = f"\n{similarity[0][0]:.5}\n" + para_list[index]
            cur_para_simple = "\n" + para_list[index]
            cur_para_vec = vec
    if len(cur_para)>0:
        para_split.append(cur_para)
        para_split_simple.append(para_split_simple)
    return para_split,para_split_simple
def split_simple(para,split_threshold):
    para_list = para.split("\n")
    para_split = []
    para_split_simple = []
    cur_para = para_list[0]
    cur_para_simple = para_list[0]
    cur_para_vec = embedding.embed_query(cur_para)
    cur_para_vec = np.array(cur_para_vec).reshape(1,-1)
    for index in range(1,len(para_list)):
        vec = embedding.embed_query(para_list[index])
        vec = np.array(vec).reshape(1,-1)
        similarity = cosine_similarity(cur_para_vec,vec)[0][0]
        if similarity > split_threshold:
            cur_para += f"\n{similarity:.5}\n" + para_list[index]
            cur_para_simple += "\n" + para_list[index]
        else:
            para_split.append(cur_para)
            para_split_simple.append(cur_para_simple)
            cur_para = f"\n{similarity:.5}\n" + para_list[index]
            cur_para_simple = "\n" + para_list[index]
        cur_para_vec = vec
    return para_split,para_split_simple
        
def split_para_func(para,split_method,split_threshold,split_threshold_para,marge_threshold_para=0):
    if para == "":
        return "",""
    # para = para.replace("\n\n","\n")
    if split_method == "基于连续两句话相似度分割":
        para_split,para_split_simple = split_simple(para,split_threshold)
    elif split_method == "基于已分割段落与句子相似度分割":
        para_split,para_split_simple = split_adapt(para,split_threshold_para)
    elif split_method == "基于已分割和连续同时判断":
        para_split,para_split_simple = split_adapt_both(para,split_threshold,split_threshold_para)
    elif split_method == "基于已分割和连续同时判断，并合并独立段落":
        para_split,para_split_simple = split_plus(para,split_threshold,split_threshold_para,marge_threshold_para)
    # return "\n############################\n---段落分割符---\n############################\n".join(para_split),"\n############################\n---段落分割符---\n############################\n".join(para_split_simple)
    
    markdown_detail = ""
    for i,para in enumerate(para_split):
        markdown_detail += "### 第"+str(i+1)+"段  \n&ensp;&ensp;&ensp;&ensp;" + para.replace("\n","  \n&ensp;&ensp;&ensp;&ensp;") + "  \n"
    markdown_simple = ""
    for i,para in enumerate(para_split_simple):
        markdown_simple += "### 第"+str(i+1)+"段  \n&ensp;&ensp;&ensp;&ensp;" + para.replace("\n","  \n&ensp;&ensp;&ensp;&ensp;") + "  \n"
    return markdown_detail,markdown_simple
    # return "\n\n".join(para_split), "\n------------------------------------new_para----------------------------------\n".join(para_split_simple)
def main():
    with gr.Blocks() as demo:
        split_method = gr.Radio(choices=["基于连续两句话相似度分割","基于已分割段落与句子相似度分割","基于已分割和连续同时判断","基于已分割和连续同时判断，并合并独立段落"], label="分割方式",value="基于连续两句话相似度分割")
        with gr.Row():
            split_threshold = gr.Slider(0.5,1.0,label="句子相似度阈值", value=0.8,step=0.01)
            split_threshold_para = gr.Slider(0.5,1.0,label="段落相似度阈值", value=0.75,step=0.01)
            marge_threshold_para = gr.Slider(0,1.0,label="合并相似度阈值", value=0.5,step=0.01)
        with gr.Row():
            ori_para = gr.Textbox(label="原始文本", placeholder="请输入一段文本",interactive=True,lines=40,max_lines=40)
            with gr.Tab("详细"):
                split_para = gr.Markdown(label="分割后的文本",interactive=True)
            with gr.Tab("简单"):
                split_para_simple = gr.Markdown(label="分割后的文本",interactive=True)
        split_btn = gr.Button(value = "点击分割")
        split_btn.click(lambda:gr.Button(interactive=False),[],[split_btn]).then(
            split_para_func,[ori_para,split_method,split_threshold,split_threshold_para,marge_threshold_para],[split_para,split_para_simple]
        ).then(
            lambda:gr.Button(interactive=True),[],[split_btn]
        )
        split_threshold.change(
            split_para_func,[ori_para,split_method,split_threshold,split_threshold_para,marge_threshold_para],[split_para,split_para_simple]
        )
        split_threshold_para.change(
            split_para_func,[ori_para,split_method,split_threshold,split_threshold_para,marge_threshold_para],[split_para,split_para_simple]
        )
        marge_threshold_para.change(
            split_para_func,[ori_para,split_method,split_threshold,split_threshold_para,marge_threshold_para],[split_para,split_para_simple]
        )
        gr.Examples([para2],inputs=[ori_para])
    demo.launch(share=False, inbrowser=True,server_name="0.0.0.0")
    
if __name__ == "__main__":
    main()


