from langchain.prompts import PromptTemplate


chatglm3_prompt_tfq = """<|system|>
你是一个可以将一段文本根据其内容生成可以用于考试的判断题，并按照一定格式进行输出的工具。具体的输出格式如下所示:
试题1：
题目：。
答案：正确/错误。
解析：用到的资料中的内容。

试题2：
题目：。
答案：正确/错误。
解析：用到的资料中的内容。
...
<|user|>
请你根据下面这段文本生成{num_selector}个判断题。
文本内容如下：
{context}"""

chatglm3_prompt_mcq = """<|system|>
你是一个可以将一段文本根据其内容生成可以用于考试的选择题，并按照一定格式进行输出的工具，具体的输出格式如下所示:
试题1：
题目：。
A.选项内容    B.选项内容    C.选项内容    D.选项内容
正确答案：给出具体选项。

试题2：
题目：。
A.选项内容    B.选项内容    C.选项内容    D.选项内容
正确答案：给出具体选项。
...
<|user|>
请你根据下面这段文本生成{num_selector}个选择题。
文本内容如下：
{context}"""

qianfan_prompt_tfq = """'''
{context}
'''

请根据上面提供的知识资料，生成可以作为考试的判断题，并给出正确答案，一共输出{num_selector}个问题。按照如下格式进行回答：
试题1：
题目：试题内容。
正确答案：正确/错误
解析：选择原因（如果用到原资料中的内容，请列出来）

试题2：
题目：试题内容。
正确答案：正确/错误
解析：选择原因（如果用到原资料中的内容，请列出来）

...
"""

qianfan_prompt_mcq = """'''
{context}
'''

请你根据上面这一段文本的内容生成可以用于考试的选择题，并按照一定格式进行输出，一共输出{num_selector}个问题。具体的输出格式如下所示:
试题1：
题目：
A.选项内容
B.选项内容
C.选项内容
D.选项内容
正确答案：给出具体选项。

试题2：
题目：
A.选项内容
B.选项内容
C.选项内容
D.选项内容
正确答案：给出具体选项。

...
"""

chatglm3_prompt_qa = """请根据以下资料内容生成{num_selector}个问答对。（请你按照以下格式进行回答）
Q：问题
A：答案

Q：问题
A：答案

...
资料内容如下所示：
{context}"""

qianfan_prompt_qa = """'''
{context}
'''

请根据以上资料内容生成{num_selector}个问答对。（请你按照以下格式进行回答）
Q：问题
A：答案

Q：问题
A：答案

...
"""

# chatglm3_prompt_struct_s1 = """<|system|>
# 你是一个可以将一段文本根据其内容将其划分为{p_number}段并按照一定格式进行输出的工具。你需要按照如下的格式进行输出：
# 段落1：
# 段落内容

# 段落2：
# 段落内容

# ...
# （注意：必须保证所有的段落内容之和为文本原文）
# <|user|>
# 文本内容如下：
# {context}"""

chatglm3_prompt_struct_s2 = """{context}

请为上述文本取一个标题（除标题之外不可输出其他内容）。"""

# qianfan_prompt_struct_s1 = """文本内容如下：
# '''
# {context}
# '''

# 你需要将上述文本根据其内容将其划分为{p_number}段并按照如下的格式进行输出：
# 段落1：
# 段落内容

# 段落2：
# 段落内容

# ...
# （注意：原始文本内容必须全部被分割）"""

qianfan_prompt_struct_s2 = """'''
{context}
'''

请为上述文本取一个标题（输出绝对不可出现除标题之外的字）："""

chatglm3_prompt_typos1 = """{context}

已知有上述文本，现需要你仔细阅读上述资料，更正资料中的错别字并将文本语气更改为{tone}语气之后进行输出。你需要按照如下的格式进行输出：
更正之后的资料：
"""

qianfan_prompt_typos1 = """'''
{context}
'''

已知有上述文本，现需要你仔细阅读上述资料，更正资料中的错别字并将文本语气更改为{tone}语气之后进行输出。你需要按照如下的格式进行输出：
更正之后的资料：
"""

chatglm3_prompt_typos2 = """{context}

已知有上述文本，现需要你仔细阅读上述资料，更正资料中的错别字之后进行输出。你需要按照如下的格式进行输出：
更正之后的资料：
"""

qianfan_prompt_typos2 = """'''
{context}
'''

已知有上述文本，现需要你仔细阅读上述资料，更正资料中的错别字之后进行输出。你需要按照如下的格式进行输出：
更正之后的资料：
"""

qianfan_prompt_stc1 = """'''
{context}
'''

请为上述文本取一个简短的标题，不要出现任何标点符号。"""


qianfan_prompt_stc2 = """'''
{context}
'''

请为上述文本取一个简短的标题，不要出现任何标点符号。"""


chatglm3_prompt_stc1 = """{context}

请为上述文本取一个标题（除标题之外不可输出其他内容）。"""



chatglm3_prompt_stc2 = """{context}

请为上述文本取一个标题（除标题之外不可输出其他内容）。"""



QIANFAN_PROMPT_STC1 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_stc1)
QIANFAN_PROMPT_STC2 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_stc2)
CHATGLM3_PROMPT_STC1 = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_stc1)
CHATGLM3_PROMPT_STC2 = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_stc2)
CHATGLM3_PROMPT_TFQ = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_tfq)
CHATGLM3_PROMPT_MCQ = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_mcq)
QIANFAN_PROMPT_TFQ = PromptTemplate(input_variables=["context"], template=qianfan_prompt_tfq)
QIANFAN_PROMPT_MCQ = PromptTemplate(input_variables=["context"], template=qianfan_prompt_mcq)
CHATGLM3_PROMPT_QA = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_qa)
QIANFAN_PROMPT_QA = PromptTemplate(input_variables=["context"], template=qianfan_prompt_qa)
# CHATGLM3_PROMPT_STRUCT_S1 = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_struct_s1)
CHATGLM3_PROMPT_STRUCT_S2 = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_struct_s2)
# QIANFAN_PROMPT_STRUCT_S1 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_struct_s1)
QIANFAN_PROMPT_STRUCT_S2 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_struct_s2)
CHATGLM3_PROMPT_TYPOS1 = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_typos1)
QIANFAN_PROMPT_TYPOS1 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_typos1)
CHATGLM3_PROMPT_TYPOS2 = PromptTemplate(input_variables=["context"], template=chatglm3_prompt_typos2)
QIANFAN_PROMPT_TYPOS2 = PromptTemplate(input_variables=["context"], template=qianfan_prompt_typos2)