import sys
sys.path.append("../..") 

from loader import load

def extract_values(values,content, elements, extractor):
    doc = "\n".join(content)
    eles = extractor.extract_foreach(doc, elements)
    # eles = extractor.extract(doc, elements)
    for e in eles:
        try:
            k, v = e.split("：", maxsplit=1)
            k = k.strip()
            v = v.strip()
            if v is not None and v != "" and v != "未知" and k in elements:
                values[k] = v + "," + values[k] if k in values else v
        except Exception as exp:
            print(exp)
            print(e)
            continue
    return values

def contract(extractor,file,elements,max_length):
    print(file,elements,max_length)
    docs = load(file)
    if docs is None:
        return "Error: could not load file"
    print(len(docs))
    content = []
    content_len = 0
    values={k:"" for k in elements}
    for d in docs:
        if content_len+len(d.page_content)>max_length:
            values = extract_values(values,content, elements, extractor)
            print("\n".join([f"{k}：{v}" for k,v in values.items()]))
            content=[d.page_content]
            content_len=len(d.page_content)
        else:
            content.append(d.page_content)
            content_len+=len(d.page_content)
    values = extract_values(values,content, elements, extractor)        
    # return [f"{k}：{v}" for k,v in values.items()]
    return values