import os, sys
sys.path.append("../..") 


from dotenv import load_dotenv,find_dotenv
load_dotenv(find_dotenv())


from llm.spark import SparkLLM
from llm.chatglm import ChatGLMSerLLM
from qa.generator import QAGenerator,TrainData

from langchain.chat_models import ChatOpenAI


# llm=SparkLLM()
# llm=ChatOpenAI(model_name="gpt-3.5-turbo")
# llm=ChatOpenAI(model_name="gpt-4")
# llm=ChatGLMSerLLM(url="http://localhost:8002")

from llm.ernie import ErnieLLM, ModelType
llm = ErnieLLM(model_name=ModelType.ERNIE_LITE)

generator=QAGenerator(llm=llm)




# input='''下载网银相关软件分为一下几个步骤
# 1.使用浏览器打开浦发硅谷银行首页：https://www.spd-svbank.com/cn/
# 2.点击右上角“网上银行”登录
# 3.在登录页“登录”按钮下方，点击“下载网银软件”，跳转至软件下载界面
# 4.选择需要下载的软件点击下载按钮即可
# #Windows：
# ##Firefox /IE 10/IE 11/Edge 浏览器：安装 Firefox 扩展，网银管家，USBKEY 驱动， 密码控件，签名和证书控件。
# ##Chrome 浏览器：安装 Chrome 扩展，网银管家，USBKEY 驱动，密码控件，签名和证书控件。
# #Mac
# ##Firefox/Chrome浏览器：安装网银管家，USBKEY 驱动，密码控件，签名和证书控件。
# （为保证您正常使用我行网上银行，使用网银 USBKEY 的客户请先安装我行网银管家安全组件。我行网银管家安全组件包括系统环境、网银控件、IE 设置等安全检测及网银USBKEY 管理工具，可一次性完成网银所需的所有控件及驱动程序的安装。）
# '''

input='''季度对账的页面描述，1、进入银企对账账户列表页面，点击银企对账，进入对账单列表页面，点击对账提交，进入对账单明细页面，选择对账状态，若为对账不相符，对账疑义为必输字段，若为对账相符，对账疑义可不输。
2、进入银企对账账户列表页面，点击对账详情，进入对账单列表页面，点击对账详情，进入对账单明细页面，可选择打印对账单明细数据。
3、对账单列表和对账单明细可下载pdf文件和excel文档。
'''

result=[]
# questions = generator.generate_questions(input,question_number=3)
# print("questions:",questions)
# print("---"*10)
# for q in questions:
#     answer=generator.generate_answer(input,q)
#     print("Q:",q,"\nA:",answer)
#     print("----"*10)

train_data_gen=TrainData(llm=llm)
train_data=train_data_gen.generate(input,question_number=3)
print(train_data)