import json
import matplotlib.pyplot as plt
import numpy as np
# 加载 json 文件
# 读取其中的 log_history 列表数据
# 基于 log_history 列表数据，绘制 loss 曲线图
def load_json(file_path):
    with open(file_path, 'r') as f:
        data = json.load(f)
        return data
    
dataset_chatglm = [
    {"chatglm1-6b-spdsvb":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/chatglm-6b-spdsvb/eval_results.json"},
    # {"chatglm-6b-pt-spdsvb-128-1e-3-3000-v1":'/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/adgen-chatglm-6b-pt-spdsvb-128-1e-3-3000/eval_results.json'},
    # {"chatglm-6b-pt-spdsvb-128-1e-3-3000-v2":'/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/adgen-chatglm-6b-pt-spdsvb-128-1e-3-3000-v2/eval_results.json'},
    {"chatglm-6b-pt-spdsvb-128-5e-3-3000-base":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/adgen-chatglm-6b-pt-128-5e-3-3000-spdsvb-base/eval_results.json"},
    {"chatglm-6b-lora-spdsvb-base":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/chatglm-6b-lora-spdsvb-base/eval_results.json"},
    {"chatglm-6b-lora-spdsvb-base-5e-3-50":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/chatglm-6b-lora-spdsvb-base-5e-3-50/eval_results.json"},    
    {"chatglm-6b-lora-spdsvb-INSv4-1e-03-50":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/chatglm-6b-lora-spdsvb-INSv4-1e-03-50/eval_results.json"},
    {"chatglm-qlora-t1":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/chatglm-qlora-t1/eval_results.json"},  
    {"chatglm-6b-qlora-spdsvb-v4_t32":"/home/zfh/ChatGLM/ChatGLM-6B/ptuning/output/chatglm-6b-qlora-spdsvb-v4_t32/eval_results.json"},
]

labels = [
    "base",
    # "pt-v1",
    # "pt-v2",
    "pt-base",
    "alora-base",
    "alora-5e3-base",
    "alora-5e3-v4",
    "qlora-base",
    "qlora-v4",
]

dataset_chatglm2 = [
    {"chatglm2-6b-spdsvb":"/home/zfh/ChatGLM/ChatGLM2-6B/ptuning/output/chatglm2-6b/spdsvb-base/eval_results.json"},
    {"chatglm2-6b-pt-spdsvb-base":"/home/zfh/ChatGLM/ChatGLM2-6B/ptuning/output/adgen-chatglm2-6b-pt-128-5e-4-spdsvb-base/eval_results.json"},
    {"chatglm2-6b-lora-spdsvb":"/home/zfh/models/tunning/chatglm2-6b-lora-spdsvb/eval_results.json"},
    {"chatglm2-6b-lora-spdsvb-v3":"/home/zfh/models/tunning/chatglm2-6b-spdb-v3/eval_results.json"},    
    
]
labels2 = [
    "2-base",
    "2-pt-base",
    "2-lora-v1",
    "2-lora-v3",  
]

def bar_eval(x,width,data,label):
    y = data
    plt.bar(x, y, width=width, label=label)
    plt.plot(x, y, '-o')
    plt.legend()

def create_plot(dataset,labels,name):
    plt.figure(figsize=(10, 4))
    bleu_4,rouge_1,rouge_2,rouge_l = [],[],[],[]
    for item in dataset:
        for key,value in item.items():
            eval_data = load_json(value)
            bleu_4.append(eval_data['eval_bleu-4'])
            rouge_1.append(eval_data['eval_rouge-1'])
            rouge_2.append(eval_data['eval_rouge-2'])
            rouge_l.append(eval_data['eval_rouge-l'])

    x=np.arange(len(labels))
    plt.xticks(x,labels)
    width = 0.1
    bar_eval(x-1.5*width,width,bleu_4,'bleu-4')
    bar_eval(x-0.5*width,width,rouge_1,'rouge-1')
    bar_eval(x+0.5*width,width,rouge_2,'rouge-2')
    bar_eval(x+1.5*width,width,rouge_l,'rouge-l')
    plt.title("chatglm-6b spdsvb eval")
    plt.savefig(f'../../images/eval/{name}.png')


create_plot(dataset_chatglm,labels,'chatglm')
create_plot(dataset_chatglm2,labels2,'chatglm2')