import csv
import json

import sys
sys.path.append("..") 
from common import consts


def data_format(csv_file, jsonl_file):
    data = []

    with open(csv_file, 'r',encoding='utf-8') as f:
        reader = csv.DictReader(f)
        for row in reader:
            prompt = row['prompt']
            response = row['response']
            data.append({'prompt': prompt, 'response': response})

    with open(jsonl_file, 'w',encoding='utf-8') as f:
        for d in data:
            f.write(json.dumps(d, ensure_ascii=False) + '\n')



csv_file = '../../data/train_comb.csv'
jsonl_file = '../../data/sheet_train_comb.json'

data_format(csv_file, jsonl_file)

csv_file = '../../data/train_comb_eval.csv'
jsonl_file = '../../data/sheet_train_comb_eval.json'

data_format(csv_file, jsonl_file)
