import os
import platform
import signal
import sys
sys.path.append("../..") 

from llm.loader import ModelLoader

from common import consts
## --------- config -------------
from argparse import Namespace
cfg = Namespace()

#model
cfg.source_prefix = consts.INSTRUCTION_V1
cfg.model_name_or_path = consts.MODEL_PATH_ChatGLM  #远程'THUDM/chatglm-6b' 
cfg.quantization_bit = None #仅仅预测时可以选 4 or 8 

cfg.ckpt_path_v7 = '../../../model/ckpt/chatglm-6b-lora-spdsvb-INSv7-1e-03-50'
cfg.ckpt_path_q1 = '../../../model/ckpt/chatglm-6b-lora-single-INSq1-1e-03-50'

## --------- end config -------------

loader = ModelLoader(cfg.model_name_or_path,  cfg.quantization_bit)

model,tokenizer = loader.models()
model = model.eval()

from peft import PeftModel

print("+++++++++++++++++++++++++++")
query = "你知道结构性存款购买的业务规则是什么吗？"
if cfg.source_prefix is not None:
    query = cfg.source_prefix + query
description = """1.只有产品代码输入正确时才能进入购买页面；
2.取当前操作员可操作账号，如果账号为监管账户，则不允许操作。
3.产品说明书、产品合同，必须要客户客户阅读后才能进行提交；
4.交易全部落地流程引擎处理；
5.会根据活期账户对应的核心客户号查询该客户是否设置KYC笔笔落地的标识。设置KYC笔笔落地会发送对应的KYC落地邮件信息。（RM, CAS@spd-svbank.com,asu@spd-svbank.com）
"""
print(query)
print("--------- 标准答案 ---------")
print(description)
print("+++++++++++++++++++++++++++")
print("--------- origin ---------")
response,history = model.chat(tokenizer,query,history=None)
print(response)

# model = PeftModel.from_pretrained(model, cfg.ckpt_path_v7, adapter_name="v7").half().cuda()
# model.load_adapter(cfg.ckpt_path_q1, adapter_name="q1")

loader.load_loras({
    "v7": cfg.ckpt_path_v7,
    "q1": cfg.ckpt_path_q1,
},"v7")
model,_= loader.models()

print("----------- v7 -----------")
model.set_adapter("v7")
model = model.half()
response,history = model.chat(tokenizer,query,history=None)
print(response)
print("----------- q1 -----------")
# loader.load_lora(cfg.ckpt_path_q1,"q1")
model.set_adapter("q1")
model = model.half()
response,history = model.chat(tokenizer,query,history=None)
print(response)
print("---------------------------")
