import os
import sys

sys.path.append("../..") 

from llm.loader import ModelLoader

from common import consts
## --------- config -------------
from argparse import Namespace
cfg = Namespace()

cfg.max_source_length = 64 
cfg.max_target_length = 128

#model
cfg.model_name_or_path = consts.MODEL_PATH_ChatGLM  #远程'THUDM/chatglm-6b' 
cfg.quantization_bit = None #仅仅预测时可以选 4 or 8 

cfg.ckpt_path = '../../../model/ckpt/chatglm-6b-lora-spdsvb-INSv4-1e-03-50'
# cfg.ckpt_path = '/home/ljj/saved_files_new_range16_batch4_epoth30/chatGLM_6B_QLoRA_t32'

cfg.save_path = '/home/zfh/models/tunning/chatglm-6b-lora-spdsvb-INSv4-1e-03-50'
## --------- end config -------------

loader = ModelLoader(cfg.model_name_or_path,  cfg.quantization_bit)
loader.load_lora(cfg.ckpt_path,)
model,tokenizer = loader.models()
model = model.eval()

print(model)

model.save_pretrained(cfg.save_path,max_shard_size='2GB')
tokenizer.save_pretrained(cfg.save_path)
os.system(f"cp {cfg.model_name_or_path}/*.py {cfg.save_path}/")

# # from torchkeras import summary
# # summary(model)

import os

train_history_path = os.path.join(cfg.ckpt_path, 'train_history.json')
val_metrics_path = os.path.join(cfg.ckpt_path, 'val_metrics.json')

if os.path.exists(train_history_path):
    os.system(f"cp {train_history_path} {cfg.save_path}/")
else:
    print(f"File {train_history_path} does not exist.")

if os.path.exists(val_metrics_path):
    os.system(f"cp {val_metrics_path} {cfg.save_path}/")
else:
    print(f"File {val_metrics_path} does not exist.")
