#!/bin/bash
source common.sh

lr=1e-3
epochs=50
batch_size=4
gradient_accumulation_steps=16

python lora.py \
    --train_file ../../../data/train_spdsvb_v11.csv \
    --val_file ../../../data/val_spdsvb_v11.csv \
    --prompt_column prompt \
    --response_column response \
    --max_source_length 64 \
    --max_target_length 128 \
    --model_name_or_path $MODEL_PATH_ChatGLM2_32K \
    --epochs $epochs \
    --lr $lr \
    --batch_size $batch_size \
    --gradient_accumulation_steps $gradient_accumulation_steps \
    --ckpt_path ../../../model/ckpt/chatglm2-6b-32k-lora-spdsvb-INSv11-1e-3-50