#!/bin/bash

source common.sh

PRE_SEQ_LEN=128
LR=3e-3
STEP=3000

output_dir=../../../model/ckpt/chatglm2-6b-32k-pt-spdsvb-INSv11-$PRE_SEQ_LEN-$LR-$STEP+s1000
# train
CUDA_VISIBLE_DEVICES=0 python pt.py \
    --do_train \
    --train_file ../../../data/train_spdsvb_v11.csv \
    --validation_file ../../../data/val_spdsvb_v11.csv \
    --prompt_column prompt \
    --response_column response \
    --source_prefix $INSTRUCTION_V1 \
    --overwrite_cache \
    --model_name_or_path $MODEL_PATH_ChatGLM2_32K \
    --output_dir $output_dir \
    --overwrite_output_dir \
    --max_source_length 64 \
    --max_target_length 128 \
    --per_device_train_batch_size 4 \
    --per_device_eval_batch_size 1 \
    --gradient_accumulation_steps 16 \
    --predict_with_generate \
    --max_steps $STEP \
    --logging_steps 50 \
    --save_steps 500 \
    --evaluation_strategy steps \
    --eval_steps 100 \
    --learning_rate $LR \
    --pre_seq_len $PRE_SEQ_LEN 
    # --quantization_bit 4
    # --ptuning_checkpoint ../../../model/ckpt/chatglm2-6b-pt-spdsvb-INSv11-128-5e-3-3010/checkpoint-1000/ \