#!/bin/bash
source common.sh

lr=5e-4
epochs=30
rank=16
train_file='../../../data/train_spdsvb_v11.csv'
val_file='../../../data/val_spdsvb_v11.csv'
output_dir="../../../model/ckpt/chatglm2-6b-32k-qlora-INSv11-rank${rank}-$lr-$epochs"
log_file=${output_dir}/prefix.log
echo $log_file
prompt_text=$INSTRUCTION_V1
# --resume_from_checkpoint $output_dir/checkpoint-1000 \

python3 qlora.py \
    --train_args_json ./config_qlora.json \
    --model_name_or_path $MODEL_PATH_ChatGLM2_32K \
    --train_data_path $train_file \
    --eval_data_path $val_file \
    --xname prompt \
    --yname response \
    --prompt_text $prompt_text \
    --output_dir $output_dir \
    --lora_rank $rank \
    --lora_dropout 0.05 \
    --compute_dtype fp32 \
    --learning_rate $lr \
    --num_train_epochs $epochs